/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;

import com.sun.java.swing.event.*;
import com.sun.java.swing.*;


public class Resource {
  private ResourceBundle resources;

  public Resource() {
    /*
    try {
      resources = ResourceBundle.getBundle("BurnIT", Locale.getDefault());
    } catch (MissingResourceException mre) {
      System.err.println("BurnIT.properties not found");
      System.exit(1);
    } 
    */
  }

  // Get resource string
  protected String getResourceString(String nm) {
    String str;
    try {
      str = resources.getString(nm);
    } catch (MissingResourceException mre) {
      str = null;
    }
    return str;
  }

  public String getGeneral() {
    return new String("General");
    // return getResourceString("General");
  }

  public String getImageFile() {
    return new String("Image File");
    // return getResourceString("Image File");
  }

  public String getLoadContents() {
    return new String("Load Contents");
    // return getResourceString("Load Contents");
  }

  public String getFileNames() {
    return new String("File Names");
    // return getResourceString("File Names");
  }

  public String getVolumeInfo() {
    return new String("Volume Info");
    // return getResourceString("Volume Info");
  }

  public String getDataTrack() {
    return new String("Data Track");
    // return getResourceString("Data Track");
  }

  public String getAudioTracks() {
    return new String("Audio Tracks");
    // return getResourceString("Audio Tracks");
  }

  public String getMkisofs() {
    return new String("mkisofs");
    // return getResourceString("Mkisofs");
  }

  public String getCdrecord() {
    return new String("cdrecord");
    // return getResourceString("Cdrecord");
  }

  public String getDisc2Disc() {
    return new String("Disc-2-Disc");
    // return getResourceString("Disc2Disc");
  }

  public String getBootFile() {
    return new String("Bootable CD");
    // return getResourceString("Bootable");
  }

  public String getNewToolTip() {
    return new String("New");
    // return getResourceString("newToolTip");
  }

  public String getOpenToolTip() {
    return new String("Open");
    // return getResourceString("openToolTip");
  }

  public String getSaveToolTip() {
    return new String("Save");
    // return getResourceString("saveToolTip");
  }

  public String getPasteToolTip() {
    return new String("Paste");
    // return getResourceString("pasteToolTip");
  }

  public String getWizardToolTip() {
    return new String("BurnIT Wizard");
    // return getResourceString("wizardToolTip");
  }

  public String getSelectToolTip() {
    return new String("Select CD-Writer");
    // return getResourceString("selectToolTip");
  }

  public String getDiscInfoToolTip() {
    return new String("Disc Info and Tools");
    // return getResourceString("discInfoToolTip");
  }

  public String getEraseToolTip() {
    return new String("Erase Disc");
    // return getResourceString("eraseToolTip");
  }

  public String getEjectToolTip() {
    return new String("Eject");
    // return getResourceString("ejectToolTip");
  }

  public String getWriteToolTip() {
    return new String("Write!");
    // return getResourceString("writeToolTip");
  }

  public String getDeleteToolTip() {
    return new String("Delete");
    // return getResourceString("deleteToolTip");
  }

  public String getDeleteAllToolTip() {
    return new String("Delete All");
    // return getResourceString("deleteAllToolTip");
  }

  public String getMoveUpToolTip() {
    return new String("Move Up");
    // return getResourceString("moveUpToolTip");
  }

  public String getMoveDownToolTip() {
    return new String("Move Down");
    // return getResourceString("moveDownToolTip");
  }

  public String getRefreshToolTip() {
    return new String("Refresh Totals");
    // return getResourceString("refreshToolTip");
  }

  public String getCDPlayerToolTip() {
    return new String("CD Player");
    // return getResourceString("cdplayerToolTip");
  }

  public String getFileManagerToolTip() {
    return new String("File Manager");
    // return getResourceString("filemanagerToolTip");
  }

  public String getHelpToolTip() {
    return new String("Help Topics");
    // return getResourceString("helpToolTip");
  }

}
