/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import java.io.*;
import java.util.*;

public class sysinfo {

  public static void main(String argv[]) {
    Vector dev = new Vector();
    Utils utils = new Utils();
    
    System.out.println("==================================================");
    System.out.println("BurnIT sysinfo v1.0");
    System.out.println("==================================================");

    System.out.print("BurnIT Version : ");
    System.out.println(utils.getVersion());
    System.out.println("==================================================");
    System.out.print("OS Name    : ");
    System.out.println(System.getProperty("os.name"));
    System.out.print("OS Arch    : ");
    System.out.println(System.getProperty("os.arch"));
    System.out.print("OS Version : ");
    System.out.println(System.getProperty("os.version"));
    System.out.println("==================================================");

    System.out.print("JAVA Version       : ");
    System.out.println(System.getProperty("java.version"));
    System.out.print("JAVA Vendor        : ");
    System.out.println(System.getProperty("java.vendor"));
    System.out.print("JAVA Vendor URL    : ");
    System.out.println(System.getProperty("java.vendor.url"));
    System.out.print("JAVA Class Version :");
    System.out.println(System.getProperty("java.class.version"));
    System.out.print("JAVA Class Path    :");
    System.out.println(System.getProperty("java.class.path"));
    System.out.print("JAVA Home          :");
    System.out.println(System.getProperty("java.home"));
    System.out.print("JAVA Compiler      :");
    System.out.println(System.getProperty("java.compiler"));
    System.out.println("==================================================");

    System.out.print("Run by : ");
    System.out.println(System.getProperty("user.name"));
    System.out.println("==================================================");

    try {
      Process procSETUP = Runtime.getRuntime().exec("ls -l cdrecord",null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line; 
      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	System.out.println(line);
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    System.out.println("");
 
    try {
      Process procSETUP = Runtime.getRuntime().exec("./cdrecord -scanbus",null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line; 
      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	System.out.println(line);
	if (line.endsWith("Removable CD-ROM")) {
	  dev.addElement(line.substring(4,5));
	}
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    System.out.println("");
    
    if (dev.size() > 0) {
      while (dev.isEmpty() == false) {
	try {
	  String command = new String("./cdrecord");
	  command = command.concat(" dev=0,");
	  command = command.concat((String)dev.firstElement());
	  command = command.concat(",0 -checkdrive");
	  dev.removeElementAt(0);
	  Process procSETUP = Runtime.getRuntime().exec(command,null);
	  MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
	  
	  String line; 
	  while (lineIn.eos() == false) {
	    line = lineIn.readLine();
	    System.out.println(line);
	  }
	  procSETUP.destroy();
	} catch (Exception e) {
	}
	System.out.println("");
      }
    }
  }
}
