#ifndef switches_file
#define switches_file

// This options can be turned off using a leading underscore.

#define USEWAITCURS
#define _VERBOSEMESSAGES
#define _SLOTLOG
#define _KDE2

// for non-linux-system (e.g. BSD):
// define _USESHM instead of USESHM and set MAXBUFFERSIZE
// to a value matching your system
#define USESHM
#define MAXBUFFERSIZE 32


#define BURNCMD    "cdrecord -v "
#define BC_FS      "fs="
#define BC_SPEED   "speed="
#define BC_DEV     "dev="
#define BC_DUMMY   "-dummy "
#define BC_PAD     "-pad "
#define BC_EJECT   "-eject "
#define BC_DATA    "-data "
#define BC_MULTI   "-multi "
#define BC_ISOSIZE "-isosize "

/*
#define BURNCMD    "burncd "
#define BC_FS      ""
#define BC_SPEED   "-s "
#define BC_DEV     "-f "
#define BC_DUMMY   "-t "
#define BC_PAD     ""
#define BC_EJECT   "-e "
#define BC_DATA    ""
#define BC_MULTI   ""
#define BC_ISOSIZE ""
*/


#endif // switches_file



