#ifndef PrefGeneric_h
#define PrefGeneric_h

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpixmap.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qradiobutton.h>
#include <qframe.h>
#include <qlineedit.h>
#include <qlabel.h>

class PrefGeneric : public QFrame
{
	Q_OBJECT

public:

	PrefGeneric( QWidget* parent = NULL, const char* name = NULL );
	virtual ~PrefGeneric();

	QButtonGroup* ButtonGroup_tag_version;
	QCheckBox* CheckBox_readAll;
	QCheckBox* CheckBox_Capital_filename;
	QCheckBox* CheckBox_replace;
	QLabel *Label_replace;
	QLineEdit *LineEdit_replace1,
		  *LineEdit_replace2;
	QRadioButton* RadioButton_tag_v1;
	QRadioButton* RadioButton_tag_v11;
	QRadioButton* RadioButton_tag_v2;

protected:
	QGroupBox *box;

};

#endif
