#include "PrefStartup.h"
#include <kapp.h>
#include <klocale.h>
#include <krabwidget.h>

PrefStartup::PrefStartup ( QWidget* parent, const char* name )
{
	box = new QGroupBox(this,"box");
	box->setGeometry(10,10,520,420);

	CheckBox_startUp_syscheck = new QCheckBox( this, "CheckBox_startUp_syscheck" );
	CheckBox_startUp_syscheck->setGeometry( 20, 20, 450, 30 );
	CheckBox_startUp_syscheck->setMinimumSize( 0, 0 );
	CheckBox_startUp_syscheck->setMaximumSize( 32767, 32767 );
	CheckBox_startUp_syscheck->setFocusPolicy( QWidget::TabFocus );
	CheckBox_startUp_syscheck->setBackgroundMode( QWidget::PaletteBackground );
	CheckBox_startUp_syscheck->setFontPropagation( QWidget::NoChildren );
	CheckBox_startUp_syscheck->setPalettePropagation( QWidget::NoChildren );
	CheckBox_startUp_syscheck->setText( i18n( "Check the system every time krabber is started." ) );
	CheckBox_startUp_syscheck->setAutoRepeat( FALSE );
	CheckBox_startUp_syscheck->setAutoResize( FALSE );

	CheckBox_startUp_openCD = new QCheckBox( this, "CheckBox_startUp_openCD" );
	CheckBox_startUp_openCD->setGeometry( 20, 70, 450, 30 );
	CheckBox_startUp_openCD->setMinimumSize( 0, 0 );
	CheckBox_startUp_openCD->setMaximumSize( 32767, 32767 );
	CheckBox_startUp_openCD->setFocusPolicy( QWidget::TabFocus );
	CheckBox_startUp_openCD->setBackgroundMode( QWidget::PaletteBackground );
	CheckBox_startUp_openCD->setFontPropagation( QWidget::NoChildren );
	CheckBox_startUp_openCD->setPalettePropagation( QWidget::NoChildren );
	CheckBox_startUp_openCD->setText( i18n("Show CD content on every time krabber is started.") );
	CheckBox_startUp_openCD->setAutoRepeat( FALSE );
	CheckBox_startUp_openCD->setAutoResize( FALSE );
	CheckBox_startUp_openCD->setEnabled( FALSE );

	QLineEdit_scan_device = new QLineEdit( this, "LineEdit_scan_device" );
	QLineEdit_scan_device->setGeometry( 150, 120, 180, 30 );
	QLineEdit_scan_device->setText( "" );

	QLabel_scan_device = new QLabel( i18n("scan device:"), this, "QLabel_scan_device" );
	QLabel_scan_device->setGeometry( 20, 120, 125, 30 );

	resize( 500,340 );
	setMinimumSize( 0, 0 );
	setMaximumSize( 32767, 32767 );
}


PrefStartup::~PrefStartup()
{
}
