#ifndef __DIALOG_CDDALIST__
#define __DIALOG_CDDALIST__

#include <qpushbutton.h>
#include <qlistbox.h>
#include <qdialog.h>
//#include "strstream.h"
#include "iostream.h"
#include "kprocess.h"
#include "qstring.h"
#include "todolist.h"

#include <detect_kde_version.h>

#ifdef KDE2
#include <qmessagebox.h>
#else
#include <kmsgbox.h>
#endif

class cddalist : public QWidget {
	Q_OBJECT
public:
	cddalist( QWidget *parent = 0 , const char *name = 0, TodoList *tdlist = NULL, bool show_select=1 );
	~cddalist();

	unsigned long disc_id;
	QString disc_id_cdindex;

signals:
        void destroy_cddalist();

protected:
	TodoList *todolist_p;
	offset_frame frame;

protected slots:
	void cdda2cdr_list_dead(KProcess *);
	void cdda2cdr_list_stdout_read(KProcess *, char * ,int );
	void QPushButton_ok_clicked();
	void QPushButton_takeall_clicked();
	void QPushButton_cancel_clicked();
	void closeEvent( QCloseEvent * );
	unsigned long cddb_discid();
	int cddb_sum(int n);
	unsigned int char2int( const char *pointer );
	unsigned int char2int( QString string );
	QString cdindex_calc();

private:
	QString time[99],
	        nodes[99],
	        cddalist_temp;
	unsigned long absolute_frames;
	bool    show_select;

	QPushButton *QPushButton_ok;
	QPushButton *QPushButton_takeall;
	QPushButton *QPushButton_cancel;
	QListBox *QListBox_CDDA;
	KProcess cdda2cdr_list;
	void initLayout(void);

private slots:
};
#endif /* __DIALOG_CDDALIST__ */


       
