#include <krabwidget.h>

void KrabWidget::doit_write_prog( unsigned int process_nr )
{
	QString temp, temp2;
	QDir path;

	outputfilename[ process_nr ]  = todolist->outputPath + "/";
	if ( todolist->create_dir_group )
	{
		outputfilename[process_nr] += todolist->data[ write_jobnumber ]->group;
		if ( !path.exists( outputfilename[process_nr], 1 ) )
			path.mkdir( outputfilename[process_nr], 1 );
		outputfilename[process_nr] += "/";
	}
	if ( todolist->create_dir_album )
	{
		outputfilename[process_nr] += todolist->data[ write_jobnumber ]->album;
		if ( !path.exists( outputfilename[process_nr], 1 ) )
			path.mkdir( outputfilename[process_nr], 1 );
		outputfilename[process_nr] += "/";
	}
	outputfilename[process_nr] += todolist->data[write_jobnumber]->output_filename;
	temp = todolist->data[write_jobnumber]->output_filename + ".";
 	if ( temp.mid(0,11) == "KrabberFile" )
		outputfilename[process_nr] += format_out[todolist->grab_mode];

	write_prog_final_size[process_nr] = todolist->length_bytes_output(write_jobnumber, dest_bitrate, dest_channels, dest_bits);

	if (todolist->grab_mode == 0 || todolist->grab_mode > 15)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "mv" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
 		temp = *tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << "-f" << temp << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
		return;
	};
	if (todolist->grab_mode == 1)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum( nice_level );
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_lame_br->text(QComboBox_lame_br->currentItem());
		temp2.setNum( bitrate_lame[QComboBox_lame_br->currentItem()] );
 		*write_prog[process_nr] << "lame" << "-m";
		if ( !QCheckBox_stereo->isChecked() )
			*write_prog[process_nr] << "m" << "-a";
		else
			*write_prog[process_nr] << "j";
		temp2.setNum(bitrate_lame[QComboBox_lame_br->currentItem()]) ;
		*write_prog[process_nr] << "-S" << "-b" << temp2;
		if ( dest_bitrate==32000 )
			*write_prog[process_nr] << "-s" << "32.0";
		if ( dest_bitrate==44100 )
			*write_prog[process_nr] << "-s" << "44.1";
		if ( dest_bitrate==48000 )
			*write_prog[process_nr] << "-s" << "48.0";
        	if ( QCheckBox_lame_copyright->isChecked() )
			*write_prog[process_nr] << "-c";
		if ( QCheckBox_lame_original->isChecked() )
			*write_prog[process_nr] << "-o";
		if ( QCheckBox_lame_fast->isChecked() )
			*write_prog[process_nr] << "-f";
		if ( QCheckBox_lame_gui->isChecked() )
			*write_prog[process_nr] << "-g";
		if ( QComboBox_lame_ql->currentItem() < 10 ) {
			temp2.setNum(QComboBox_lame_ql->currentItem());
			*write_prog[process_nr] << "-v" << "-V" << temp2;
		};
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << outputfilename[process_nr] ;
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

 		temp = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp );
	};
	if (todolist->grab_mode == 2)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum(nice_level);
		*write_prog[process_nr] << "-n" << temp;
   		temp = QComboBox_8hz_br->text(QComboBox_8hz_br->currentItem());
		temp2.setNum( bitrate_8hz[QComboBox_8hz_br->currentItem()] );
 		*write_prog[process_nr] << "8hz-mp3" << "-b" << temp2;
		if ( QCheckBox_8hz_copyright->isChecked() )
			*write_prog[process_nr] << "-c";
		if ( QCheckBox_8hz_original->isChecked() )
			*write_prog[process_nr] << "-o";
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1] << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 3)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum(nice_level);
		*write_prog[process_nr] << "-n" << temp;
		temp2.setNum(bitrate_l3[QComboBox_l3_br->currentItem()]);
#ifdef KDE2
 		*write_prog[process_nr] << locate( "data", "/krabber/scripts/l3enc.start" );
#else
 		*write_prog[process_nr] << KApplication::kde_datadir() + "/krabber/scripts/l3enc.start";
#endif
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1] + ".mp3" ;
		*write_prog[process_nr] << "-br" << temp2 + "000";
		if ( QCheckBox_l3_crc->isChecked() )
			*write_prog[process_nr] << "-crc";
		if ( QCheckBox_l3_hq->isChecked() )
			*write_prog[process_nr] << "-hq";
		if ( QCheckBox_l3_speech->isChecked() )
			*write_prog[process_nr] << "-spch";
		if ( !QCheckBox_stereo->isChecked() )
			*write_prog[process_nr] << "-dm";
		write_prog[process_nr]->start(KProcess::NotifyOnExit);//, KProcess::AllOutput);

		const char *temp_p = temp;
		write_prog_file[process_nr] = new QFile( temp_p );
	};

	if (todolist->grab_mode == 4)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum(nice_level);
		*write_prog[process_nr] << "-n" << temp;
		temp2.setNum(bitrate_mp3[QComboBox_mp3_br->currentItem()]);
		temp2 += "000";
		*write_prog[process_nr] << "mp3enc" << "-br" << temp2 << "-qual";
		temp.setNum(QComboBox_mp3_ql->currentItem());
		*write_prog[process_nr] << temp;
		if ( QCheckBox_mp3_crc->isChecked() )
			*write_prog[process_nr] << "-crc";
		if ( !QCheckBox_stereo->isChecked() )
			*write_prog[process_nr] << "-dm";
 		*write_prog[process_nr] << "-if" << *tempfilename[write_jobnumber-1];
		*write_prog[process_nr] << "-of" << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		const char *temp_p = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_p );
	};
	if (todolist->grab_mode == 5)
	{
		help_prog = new KProcess;
		help_prog->clearArguments();
		help_prog->setExecutable( "mv" );
		*help_prog << "-f" << *tempfilename[write_jobnumber-1] << *tempfilename[write_jobnumber-1] + ".wav";
		help_prog->start(KProcess::Block, KProcess::AllOutput);
		delete help_prog;
		help_prog = 0;

		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum( nice_level );
		*write_prog[process_nr] << "-n" << temp;
		temp2.setNum(bitrate_blade[QComboBox_blade_br->currentItem()]);
		*write_prog[process_nr] << "bladeenc" << "-quit" << "-quiet";
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1] + ".wav";
		*write_prog[process_nr] <<  "-" + temp2 ;
		if ( QCheckBox_blade_copyright->isChecked() )
			*write_prog[process_nr] << "-copyright";
		else
			*write_prog[process_nr] << "-copy";
		if ( QCheckBox_blade_private->isChecked() )
			*write_prog[process_nr] << "-private";
		if ( QCheckBox_blade_crc->isChecked() )
			*write_prog[process_nr] << "-crc";
		if ( !QCheckBox_stereo->isChecked() )
			*write_prog[process_nr] << "-mono";
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

 		temp = *tempfilename[write_jobnumber-1] + ".mp3" ;
		write_prog_file[process_nr] = new QFile( temp );
	};
	if (todolist->grab_mode == 6)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum( nice_level );
		*write_prog[process_nr] << "-n" << temp;
		temp2.setNum(bitrate_encode[QComboBox_encode_br->currentItem()]);
 		*write_prog[process_nr] << "encode" << "-l" << "3" << "-b" << temp2 << "-m";
		if ( dest_channels == 2 )
			*write_prog[process_nr] << "j";
		else
			*write_prog[process_nr] << "m";
		switch ( QComboBox_encode_ql->currentItem() ){
			case 0:
				*write_prog[process_nr] << "-q" << "0.02" ;
				break;
			case 1:
				*write_prog[process_nr] << "-q" << "0.10" ;
				break;
			case 2:
				*write_prog[process_nr] << "-q" << "0.25" ;
				break;
			case 3:
				*write_prog[process_nr] << "-q" << "0.50" ;
				break;
			case 4:
				*write_prog[process_nr] << "-q" << "0.75" ;
				break;
			case 5:
				*write_prog[process_nr] << "-q" << "1.00" ;
				break;
			case 6:
				*write_prog[process_nr] << "-q" << "2.00" ;
				break;
			case 7:
				*write_prog[process_nr] << "-q" << "5.00" ;
				break;
			case 8:
				*write_prog[process_nr] << "-q" << "10.00" ;
				break;
			case 9:
				*write_prog[process_nr] << "-q" << "25.00" ;
				break;
			case 10:
				*write_prog[process_nr] << "-q" << "50.00" ;
				break;
			case 11:
				*write_prog[process_nr] << "-q" << "99.99" ;
				break;
		};
		if ( dest_bitrate==32000 )
			*write_prog[process_nr] << "-s" << "32.0";
		if ( dest_bitrate==44100 )
			*write_prog[process_nr] << "-s" << "44.1";
		if ( dest_bitrate==48000 )
			*write_prog[process_nr] << "-s" << "48.0";
        	if ( QCheckBox_encode_copyright->isChecked() )
			*write_prog[process_nr] << "-c";
		if ( QCheckBox_encode_original->isChecked() )
			*write_prog[process_nr] << "-o";
		if ( QCheckBox_encode_crc->isChecked() )
			*write_prog[process_nr] << "-e";
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1];
		*write_prog[process_nr] << outputfilename[process_nr];
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

 		const char *temp_ = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp_ );
	};
	if (todolist->grab_mode == 7)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "nice" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));
		temp.setNum( nice_level );
		*write_prog[process_nr] << "-n";
		*write_prog[process_nr] << temp;
 		*write_prog[process_nr] << "xingmp3enc" << "-Q" << "-R" <<"-M";
		if ( QCheckBox_stereo->isChecked() )
			*write_prog[process_nr] << "1";
		else
			*write_prog[process_nr] << "3";
		if ( QCheckBox_xing_vbr->isChecked() ){
			switch( QComboBox_xing_ql->currentItem() ){
			   case 0:
				*write_prog[process_nr] << "-V" <<"1";
                                break;
			   case 1:
				*write_prog[process_nr] << "-V" <<"30";
                                break;
			   case 2:
				*write_prog[process_nr] << "-V" <<"50";
                                break;
			   case 3:
				*write_prog[process_nr] << "-V" <<"75";
                                break;
			   case 4:
				*write_prog[process_nr] << "-V" <<"100";
                                break;
			   case 5:
				*write_prog[process_nr] << "-V" <<"150";
                                break;
			   default:
				cout << "Internal Krabber Error: wrong xing_vbr"<<QComboBox_xing_ql->currentItem() <<endl;
				exit( -1 );
			};
		}else{
			temp.setNum( bitrate_xing[QComboBox_xing_br->currentItem()] );
			*write_prog[process_nr] << "-B";
			*write_prog[process_nr] << temp;
		};
		temp2.setNum( dest_bitrate );
		*write_prog[process_nr] << "-A" << temp2;

        	if ( QCheckBox_xing_copyright->isChecked() )
			*write_prog[process_nr] << "-C" << "1";
		else
			*write_prog[process_nr] << "-C" << "0";

		if ( QCheckBox_xing_original->isChecked() )
			*write_prog[process_nr] << "-O" << "1";
		else
			*write_prog[process_nr] << "-O" << "0";

		if ( QCheckBox_xing_nohigh->isChecked() )
			*write_prog[process_nr] << "-N";

                *write_prog[process_nr] << "--";
 		*write_prog[process_nr] << *tempfilename[write_jobnumber-1];
 		*write_prog[process_nr] << outputfilename[process_nr] ;
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

 		temp = outputfilename[process_nr];
		write_prog_file[process_nr] = new QFile( temp );
	};

	if (todolist->grab_mode == 15)
	{
		write_prog[process_nr] = new KProcess;
		write_prog[process_nr]->clearArguments();
		write_prog[process_nr]->setExecutable( "cdrecord" );
		connect(write_prog[process_nr], SIGNAL(processExited(KProcess *)), SLOT(write_prog_dead()));

		*write_prog[process_nr] << "dev=" + cdrecord_device_id[QComboBox_cdr_device->currentItem()+1];
		switch ( QComboBox_cdr_speed->currentItem() ){
			case 0:
				*write_prog[process_nr] << "speed=1";
				break;
			case 1:
				*write_prog[process_nr] << "speed=2";
				break;
			case 2:
				*write_prog[process_nr] << "speed=4";
				break;
			case 3:
				*write_prog[process_nr] << "speed=6";
				break;
			case 4:
				*write_prog[process_nr] << "speed=8";
				break;
		};
        	if ( QCheckBox_cdr_dummy->isChecked() )
			*write_prog[process_nr] << "-dummy";

		*write_prog[process_nr] << "-v" << "-V" ;
 		*write_prog[process_nr] << "-pad"; //no need for this if sox do a fine job, but...
 		*write_prog[process_nr] << "-nofix" << "-audio" << *tempfilename[write_jobnumber-1];
		connect(write_prog[process_nr], SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(cdrecord_out(KProcess *, char *, int  )));
		connect(write_prog[process_nr], SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(cdrecord_out(KProcess *, char *, int  )));
		write_prog[process_nr]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

		write_prog_file[process_nr] = new QFile( "/tmp" );
	};
	write_prog_final_size[process_nr] /= dest_bitrate*dest_channels*dest_bits;
	write_prog_final_size[process_nr] *= bitrate*1000;
};

void KrabWidget::write_prog_dead()
{
	unsigned int process_nr;
	QString temp;

	for ( process_nr=0; process_nr<encoder_max; process_nr++ )
	{
	  if ( write_prog_run[process_nr] == 1 && write_prog[process_nr]!=0 )
	  {
	    if ( !write_prog[process_nr]->isRunning() )
	    {
		delete write_prog[process_nr];
		write_prog[process_nr] = 0;
		if ( todolist->grab_mode == 3 || todolist->grab_mode == 5 )
		{
			// *tempfilename with << to *help_prog generates a seg fault !!
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "mv" );
			*help_prog << "-f" << *tempfilename[write_job_track[process_nr]] + ".mp3" << outputfilename[process_nr];
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			if ( todolist->grab_mode == 5 )
				temp = *tempfilename[write_job_track[process_nr]] + ".wav";
			else
				temp = *tempfilename[write_job_track[process_nr]];
			*help_prog << "-f" << temp;
			if ( !QCheckBox_tempfiles->isChecked() )
				help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
			Status->write_led( 0, process_nr );
			emit ( Status->KProgress_write[process_nr]->setValue( 0 ) );
	        }
		else if ( todolist->grab_mode > 0 && todolist->grab_mode < 16 )
		{
			// *tempfilename with << to *help_prog generates a seg fault !!
			temp = *tempfilename[write_job_track[process_nr]];
			help_prog = new KProcess;
			help_prog->setExecutable( "rm" );
			*help_prog << "-f" << temp;
			if ( QCheckBox_tempfiles->isChecked() );
				help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
			Status->write_led( 0, process_nr );
			emit ( Status->KProgress_write[process_nr]->setValue( 0 ) );
			cdrecord_progress = 0;
      		};
		QFile *output_file;
		output_file = new QFile(  outputfilename[process_nr] );
		if ( !( output_file->exists()) && todolist->grab_mode != 15 )
		{
#ifdef KDE2
		        QMessageBox::information( this, i18n ( "Error" ), i18n ( "Something went wrong.... \n\n - Maybe you have no write permission\n - or you have an incorrect filename (esp. on non ext2 filesystems)\n - or an encoder problem\n\n Sorry... hope you find the error ! :-(" ) );
#else
		        KMsgBox::message( this, i18n ( "Error" ), i18n ( "Something went wrong.... \n\n - Maybe you have no write permission\n - or you have an incorrect filename (esp. on non ext2 filesystems)\n - or an encoder problem\n\n Sorry... hope you find the error ! :-(" ) );
#endif
			kill_doit();
			return;
		};
		delete output_file;
		if ( todolist->grab_mode > 0 && todolist->grab_mode < 15
		    && QCheckBox_mp3_header->isChecked() )
			write_mp3_header( outputfilename[process_nr], write_job_track[process_nr] + 1 );
		*temp_file[write_job_track[process_nr]+1] = 0;
                write_prog_run[process_nr] = 0;
	        delete write_prog_file[process_nr];
		write_prog_file[process_nr] = 0;

		QString temp, temp2;
		jobs_finished++;
		temp = i18n ( "total job" );
		temp +=  ": ";
		temp2.setNum( jobs_finished );
		temp += temp2;
		temp += "/";
		temp2.setNum(todolist->tracks);
		temp += temp2;
		Status->QLabel_Status_total->setText( temp );

		if ( todolist->grab_mode > 0 && todolist->grab_mode < 15 )
		{
			total_finished += (unsigned long) write_prog_final_size[process_nr] ;
			needed_encd_space -= write_prog_final_size[process_nr];
		};
		if ( todolist->grab_mode == 15 ){
			total_finished += (unsigned long) todolist->length_bytes_output(write_job_track[0]+1, dest_bitrate, dest_channels, dest_bits, bitrate);
			needed_encd_space -= write_prog_final_size[process_nr];
		};
	      };
	   };
	};
};


void KrabWidget::doit_read_prog( bool force_fifo_out=0 )
{
	QString temp, temp3;

	use_fifo = 0;
	use_sox  = 0;
        temp.setNum( jobnumber );

	if ( force_fifo_out || QCheckBox_tempfiles->isChecked() )
		temp3 = FIFO + "_1" ;
	else
		temp3 = todolist->outputPath + "/Krabber_temp_file_" + todolist->krabber_process_id + "_" + temp;
	tempfilename.insert( jobnumber-1, new QString(temp3) );

	read_prog_final_size = (unsigned long) todolist->length_bytes_output(jobnumber, dest_bitrate, dest_channels, dest_bits);

	use_sox = 0;

	if ( todolist->data[jobnumber]->type > 4 || todolist->grab_mode > 14)
		use_sox = 1;

	if ( !(todolist->grab_mode < 15 && dest_bitrate==todolist->data[jobnumber]->input_rate && dest_channels==todolist->data[jobnumber]->input_channels && dest_bits==todolist->data[jobnumber]->input_bit_per_rate) )
		use_sox = 1;

	if (todolist->data[jobnumber]->type == 1)
	{
		read_prog = new KProcess;
		read_prog->clearArguments ();

	        read_prog->setExecutable ( "cdparanoia" );
	        *read_prog << "-d" <<  todolist->data[jobnumber]->device ;
	        if ( !QCheckBox_jitter->isChecked() )
			 *read_prog <<"-Z";
 		temp3.setNum( todolist->data[jobnumber]->tracknumber );
		*read_prog << temp3;
		if ( use_sox )
			use_fifo = 1;
		if ( use_fifo )
			*read_prog << FIFO;
		else
			*read_prog << *tempfilename[jobnumber - 1];
		connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		read_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	};
	if (todolist->data[jobnumber]->type == 2 || todolist->data[jobnumber]->type == 3)
	{
		read_prog = new KProcess;
		read_prog->clearArguments ();
		if ( use_sox )
		{
			use_fifo = 1;
#ifdef KDE2
			read_prog->setExecutable( locate( "data", "/krabber/scripts/mpg123.start" ) );
#else
			read_prog->setExecutable( KApplication::kde_datadir() + "/krabber/scripts/mpg123.start" );
#endif
			*read_prog << FIFO;
		} else {
			read_prog->setExecutable( "mpg123" );
			*read_prog << "-w" << *tempfilename[jobnumber - 1];
		};
		*read_prog <<todolist->data[jobnumber]->device ;
		connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		read_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
   	};
	if (todolist->data[jobnumber]->type == 4 && !use_sox )
	{
// TO FIX: try to link first.. or do something else with more sense...
		read_prog = new KProcess;
		read_prog->clearArguments ();
		read_prog->setExecutable ( "cp" );
		*read_prog << "-f";
		temp3= todolist->data[jobnumber]->device;
		*read_prog << temp3;
		*read_prog << *tempfilename[jobnumber - 1];
		connect(read_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		read_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	}
	if ( use_sox )
	{
		KProcess *temp_prog;
		if ( use_fifo )
		{
			convert_prog = new KProcess;
			temp_prog = convert_prog;
    		} else {
			read_prog = new KProcess;
			temp_prog = read_prog;
		};
		temp_prog->clearArguments ();
		temp_prog->setExecutable ( "sox" );
// INPUT PARAMETERS
	   	if ( todolist->data[jobnumber]->type == 1 )
			*temp_prog << "-t" << "wav";
		else if (todolist->data[jobnumber]->type == 2 || todolist->data[jobnumber]->type == 3)
			*temp_prog << "-t" << "raw";
		else
			*temp_prog << "-t" << format_in[todolist->data[jobnumber]->type];

		if ( todolist->data[jobnumber]->type == 7 || todolist->data[jobnumber]->type == 8 || todolist->data[jobnumber]->type == 2 || todolist->data[jobnumber]->type == 3 )
			*temp_prog << "-r" << "44100" << "-w" << "-s" << "-c" <<"2";

		if ( use_fifo )
			*temp_prog << FIFO;
		else
			*temp_prog << todolist->data[jobnumber]->device;
// OUTPUT PARAMETERS
		if ( todolist->grab_mode < 15 )
			*temp_prog << "-t" << "wav";
		else if ( todolist->grab_mode == 15 )
			*temp_prog << "-t" << "cdr";
		else
			*temp_prog << "-t" << format_out[todolist->grab_mode];

	       	temp.setNum( dest_channels );
		*temp_prog << "-c" << temp;
		temp.setNum( dest_bitrate );
		*temp_prog << "-r" << temp;
		switch( dest_bits ){
			case 8 : *temp_prog << "-b"; break;
			case 16: *temp_prog << "-w"; break;
			case 32: *temp_prog << "-l"; break;
			default: printf("INTERNAL KRABBER ERROR! WRONG BIT PER RATE\n");exit(1);
		};
 		*temp_prog << *tempfilename[jobnumber - 1];

		if ( todolist->data[jobnumber]->input_rate == dest_bitrate && todolist->data[jobnumber]->input_bit_per_rate == dest_bits && todolist->data[jobnumber]->input_channels == dest_channels )
			*temp_prog << "copy" ;
		else if ( QCheckBox_q_resample->isChecked() )
			*temp_prog << "resample" ;
		else
			*temp_prog << "rate" ;

 		connect(temp_prog, SIGNAL(processExited(KProcess *)), SLOT(read_prog_dead()));
		temp_prog->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	};

	temp = *tempfilename[jobnumber - 1];
	const char* temp_p = temp;
	read_prog_file = new QFile( temp_p ) ;
};

void KrabWidget::read_prog_dead( )
{
	QString temp;

	if ( convert_prog )
	{
		convert_prog->kill(9);
		delete convert_prog;
		convert_prog = 0;
        };

	if ( read_prog_run == 1 && !read_prog->isRunning() )
	{
		delete read_prog;
                read_prog = 0;
		Status->read_led( 0 );
		emit ( Status->KProgress_read->setValue( 0 ) );
		read_prog_run = 0;
		*temp_file[jobnumber] = 1;
		delete read_prog_file;
		read_prog_file = 0;

		double l=todolist->length_bytes(jobnumber, dest_bitrate, dest_channels, dest_bits);
		if ( todolist->grab_mode == 0 || todolist->grab_mode > 15 )
			total_finished += (unsigned long) l ;
		else
			needed_encd_space += (l*bitrate)/1344;
	}
};
