/*
	Extension for kcombo(box). if a key is pressed, the widget search the next item
        starts with this character.

	Initialy written for krabber. maybe usefull for other apps.

	http://krabber.automatix.de

	sure, this is under GPL. copyright 1999 by Adrian Schroeter

*/
#ifndef __KCOMBOEXT__
#define __KCOMBOEXT__ 

#include <kcombo.h>

class KComboExt : public KCombo
{
public:
	KComboExt( QWidget* parent = 0, const char* name = 0, WFlags f = 0 );
	KComboExt( bool readWrite, QWidget* parent = 0,
                const char* name = 0, WFlags f = 0 );
        virtual ~KComboExt(){};
/**
enables the automatic search function for an item with initial letter as 
pressed bye the user.
*/
	void setKeys( bool enable );
/**
if enable = 0 /FALSE the routine running backward.
*/
	void searchForward( bool enable );
// mabye later: a sorting function...
//	void sortList( bool forward, bool capitalSensitive );

protected:
	virtual void keyPressEvent( QKeyEvent *e );
	bool enableSearch;
	bool searchForw;

};

#endif
