/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

class AboutBox extends JFrame implements ActionListener {
  protected JPanel panel1 = new JPanel();
  protected JPanel panel2 = new JPanel();
  protected JPanel panel3 = new JPanel();
  protected JPanel panel4 = new JPanel();
  protected JPanel panel5 = new JPanel();

  protected JButton button1;

  protected JLabel  label1 = new JLabel();
  protected JLabel  label2 = new JLabel();
  protected JLabel  label3 = new JLabel();
  protected JLabel  label4 = new JLabel();
  protected JButton label5 = new JButton();

  protected ImageIcon logo;

  protected String product;
  protected String version;
  protected String copyright;
  protected String comments;
  protected String website;

  protected Font font0;
  protected Font font1;
  protected Font font2;

  protected Utils util;

  public AboutBox(Utils utl) {
    util = utl;

    this.setTitle("BurnIT: About");

    setSize(new Dimension(540,300));

    this.getContentPane().setLayout(new BorderLayout()); 

    font0 = new Font("Helvetica", Font.BOLD, 18);
    font1 = new Font("Helvetica", Font.BOLD, 14);
    font2 = new Font("Helvetica", Font.BOLD, 12);

    panel1.setLayout(new BorderLayout());
    panel2.setLayout(new FlowLayout(FlowLayout.CENTER));
    panel3.setLayout(new BorderLayout());
    panel4.setLayout(new BorderLayout());
    panel5.setLayout(new GridLayout(5,1));

    product = new String("BurnIT");
    version = new String("v");
    version = version.concat(util.getVersion());
    copyright = new String("Jesper Pedersen <jews@imada.ou.dk>  Copyright (c) 1998,1999");
    comments = new String("A JAVA front-end to mkisofs, cdrecord and cdda2wav");
    website = new String("http://sunsite.auc.dk/BurnIT/");

    label1.setText(product);
    label1.setForeground(Color.black);
    label1.setFont(font0);
    label2.setText(version);
    label2.setForeground(Color.black);
    label2.setFont(font1);
    label3.setText(copyright);
    label3.setForeground(Color.black);
    label3.setFont(font2);
    label4.setText(comments);
    label4.setForeground(Color.black);
    label4.setFont(font2);

    label5.setText(website);
    label5.setForeground(Color.black);
    label5.setFont(font2);
    label5.setBorderPainted(false);
    label5.setHorizontalAlignment(JButton.LEFT);
    label5.setForeground(Color.blue);
    label5.addActionListener(this);

    button1 = new JButton("Ok");
    button1.addActionListener(this);
    panel2.add(button1);

    JPanel logoPanel = new JPanel();
    logoPanel.setLayout(new BorderLayout());
    logo = new ImageIcon("images/BurnIT.gif");
    JLabel logoLabel = new JLabel(logo);
    logoPanel.add(logoLabel, BorderLayout.CENTER);
    logoPanel.setBorder(new EmptyBorder(10,10,10,10));
    panel4.add(logoPanel,BorderLayout.CENTER);

    panel5.add(label1);
    panel5.add(label2);
    panel5.add(label3);
    panel5.add(label4);
    panel5.add(label5);

    panel3.add(panel4, BorderLayout.WEST);
    panel3.add(panel5, BorderLayout.EAST);

    panel1.add(panel3, BorderLayout.CENTER);

    panel1.add(panel2, BorderLayout.SOUTH);

    this.getContentPane().add(panel1, BorderLayout.CENTER);

    this.setVisible(true);
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button1) {
      setVisible(false);
      dispose();
    } else if (e.getSource() == label5) {
      String cmd;
      
      cmd = new String("netscape ");
      cmd = cmd.concat(label5.getText());
      ExecuteThread th = new ExecuteThread(cmd,false);
    }
  }
}
