/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class FileNamesFrame extends JPanel {
  protected JPanel     borderPane;
  protected FileNames  dataPane;
  protected JLabel     label;
  
  protected Settings   settings;
  
  public FileNamesFrame(Settings set) {
    this.setLayout(new BorderLayout());
    
    settings = set;
    
    borderPane = new JPanel();
    borderPane.setBorder(new EmptyBorder(5,5,5,5));
    borderPane.setLayout(new BorderLayout());
    
    label = new JLabel("Data Structure");
    label.setForeground(Color.black);
    
    dataPane = new FileNames(settings,settings.getAdvancedUser());
    
    borderPane.add(label, BorderLayout.NORTH);
    borderPane.add(dataPane, BorderLayout.CENTER);
    
    this.add(borderPane, BorderLayout.NORTH);
  }
  
  // Refresh screen
  public void refresh() {
    
  }
  
  public String getBurnString() {
    return dataPane.getBurnString();
  }

  public String whichISOBuilder() {
    return dataPane.whichISOBuilder();
  }

  public void setFileSystem(String s) {
    dataPane.setFileSystem(s);
  }

}
