#!/usr/bin/perl
# 
#  Copyright (C) 1998  Jesper Pedersen <jews@imada.ou.dk>
#  This code is released under GNU GPL version 2 or later
#
#  Converts all JAVA files in current directory from Swing-1.1
#  files to Swing-1.0 files
#
#  Usage: convert2.pl         
#

while (<*.java>) {
    $name = $_;                     # Get current file name

    $infile = $name;                # Input file
    $outfile = $name . ".$$";       # Output file
    open(IN, "< $infile") || die;   # Make filehandle
    open(OUT, "> $outfile") || die; # Make filehandle
    while (<IN>) {
	s/javax/com.sun.java/g;     # Exchange "javax" with "com.sun.java"
	(print OUT);                # Write to file
    }
    close IN;                       # Close filehandle
    close OUT;                      # Close filehandle
    
    rename($outfile, $infile);      # Rename file
}
