#!/bin/sh

#startBackTool.sh v0.1
#This program starts BackTool.class with the correct environment
#Copyrigth (C)1998 - 1999  Stefan Forstmoser
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

cd `dirname $0`
PATH=`pwd`:$PATH
# If cdrecord or mkisofs is not installed, maybe we have luck with the
# versions, that came with the CDBL-package ...
which cdrecord >/dev/null 2>&1
if [ `echo $?` != "0" ]
then
	tar -xzf boot/usr.tgz bin/cdrecord
fi
which mkisofs >/dev/null 2>&1
if [ `echo $?` != "0" ]
then
	tar -xzf boot/usr.tgz bin/mkisofs
fi
[ -d "bin" ] && PATH=`pwd`/bin:$PATH

export PATH

java BackTool `pwd`
rm -f tmpcdbl.cfg

rm -rf bin

exit 0
