Program cdtux;
Uses sf,ncrt,Hgui,ucdtux,linux,crt;

Type String5 = string[5];

Var setup                : setupinfo;
    c                    : char;
    tn,tn2               : byte;
    savedir,helpline     : string;
    cdrp,cdromp          : string5;
    ext                  : string[4];
    CDTrack              : Boolean;
    scsi,helpheader      : string;
    Imported             : Boolean;
    ImportS              : String;
    T                    : Text;

Const numA: byte = 0;
      numD: Byte = 0;
      CDROM = 'CD-Rom Device';
      CDR  = 'CD-Writer Device';

Function Inm(name :String): String;
var tnum :string;
Begin
     Str(tn,tnum);
  Inm := name + tnum;
  If name[1] = 'D' Then
    inm := inm + '.trk';
End;


Function dnm(name :String;tR:byte): String;
var ts :string;
Begin
  Str(TR,TS);
  dnm := name + ts;
End;

Procedure Help;
Var N :integer;
Begin
n := 0;
Assign (T,'/usr/doc/cdtux/online/help.main');
reset (T);
Page.Refresh;
infoblock (2,3,78,23);
readln (T,helpHeader);
Writeln (HelpHeader);
While Not Eof (t) Do
Begin
   inc (N);
   If N < 18  Then
   Begin
   readln (T,Helpline);
   Writeln (Helpline)
   End Else
   Begin
   Write ('---Press Any Key For Next Page---');
   readkey;
   clrscr;
   Writeln(HelpHeader);
   N := 1;
   End;
End;
Writeln ('---Press Any Key To Return To The Image Editor---');
readkey;
        Page.refresh;
        Infoblock (2,3,78,15);
        Writeln ('CD-Tux Main Menu');
        Writeln ('A      > New Disk Image');
        Writeln ('B      > Saved Image');
        Writeln ('C      > Blank CD-RW Table Of Contents Only');
        Writeln ('D      > Full Blank CD-RW (May Take A While');
        If (NumA = 0) And (NumD = 0) Then
        Writeln ('E      > Import MultiSession');
        Writeln ('F1     > Help');
        writeln ('Escape > Quit');
End;


Procedure UsageMeter;

Var I2         : Integer;
    Percent    : Real;
    I          : Longint;
    S,S2         : String;
Begin
  popen (T,'du ' + setup.temp,'R');
  While not eof (T) Do
  Readln (T,S);
  S2 := Copy (S,1,6);

  Val (S2,I,I2);
  percent := I/650000 * 100;
  I2 := (100 * round(percent)) Div 140;
  Textbackground (Blue);
  window (2,23,78,25);
  Clrscr;
  Write ('Disk Usage:');
  Textbackground (White);
  window (3,24,77,24);
  clrscr;
  textbackground (yellow);
  Window (3,24,I2 + 3,24);
  clrscr;
  window (3,24,77,24);
  Gotoxy (36,wherey);
  Textcolor (Black);
  Textbackground(White);
  Write (Percent:3:2,'%');
  textcolor (white);
End;





Procedure selectfiles(pathn,trackn :String);

Var
    data : boolean;
    line: string;
    selectc: boolean;
    Fullpath,dirname    : string;
     cnt,num            : integer;

Procedure ls;

Procedure AudioFilter;
Begin
  popen (t,'/bin/ls -a ','R');
  while not eof (t) Do
  Begin
    readln (t,line);
    If Not Isdir(Line) Then
      Begin
        If  copy(line,length(line) - 3,4) = '.raw' Then
          name[cnt] := Line;

        If  copy(line,length(line) - 3,4) = '.wav' Then
          name[cnt] := Line;

        If  copy(line,length(line) - 3,4) = '.cdr' Then
          name[cnt] := Line;
        If copy(line,length(line) - 3,4) = '.mp3' Then
          name[cnt] := Line;

        If copy(line,length(line) - 2,3) = '.ua' Then
          name[cnt] := Line;
        inc (cnt);
      End
    Else
      Begin
        Name[cnt] := line;
        inc(cnt);
      End;
  End;
  close (t);
  num := cnt + 4;
  name[cnt + 1] := '*';
  name[cnt + 2] := '/';
  name[cnt + 3] := CDROM;
  Name[cnt + 4] := CDR;
  cnt := 1;
End;

Begin
  CDTrack := False;
  assign (t,'/var/tmp/temp.dat');
  rewrite (t);
  cnt := 1;
  While cnt <= num  Do
                Begin
                  name[cnt] := '';
                  inc(cnt);
                End;
  If Data Then
    Begin
      popen (t,'/bin/ls -a ','R');
      while not eof (t) Do
      Begin
        readln (t,line);
        name [cnt] := line;
        inc (cnt);
      End;
      close (t);
      num := cnt + 4;
      name[cnt + 1] := '*';
      name[cnt + 2] := '/';
      name[cnt + 3] := CDROM;
      Name[cnt + 4] := CDR;

      cnt := 1;
    End
  Else Audiofilter;
Close (T);
End;

Procedure Readcd (device :String);

Var S,ttype,ttime : string;
Begin
  CDTrack := True;
  cnt := 1;
  While cnt < num Do
  Begin
    name[cnt] := '';
    inc(cnt);
  End;
  cnt := 1;
  assign (t,'/tmp/toc');
  rewrite (T);
  Close (T);
  If Device = CDROM Then scsi := cdromp
  Else scsi := cdrp;
  execute ('/usr/bin/cdtux.cdda2wav -J -g -H -N "-D '+scsi+'"');
  assign (t,'/tmp/toc');
  reset (t);
  while not eof (t) Do
  Begin
    Readln (t,s);
    If (s[1] = 'T') And ((S[2] = '0') Or (S[2] = '1') Or (S[2] = '2') Or (S[2] = '3'))
      Then
      Begin
        If S[23] = 'd' Then ttype := 'Data'
        Else
          ttype := 'Audio';
        ttime := copy(S,14,8);
        name[cnt] := ttype + ' Track ' + S[2] + S[3] + ' | ' + ttime;
        name[cnt] := name[cnt];
        inc(cnt);
      End;
  End;
  num := cnt + 3;
  name[cnt + 1] := '*';
  name[cnt + 2] := '/';
  name[cnt + 3] := '..';
  close (T);
End;

Procedure RipCD(Track :String);

Var TT : string;
Begin
  If Track[1] = 'A' Then
  Begin
    Begin
      chdir (setup.temp);
      TT := Copy (Track,length(track) - 12,2);
      execute ('/usr/bin/cdtux.cdda2wav Audio_CD -g -H "-t '+ TT+ '" "-d 0" "-D '+ scsi +
               '"');
      execute ('mv Audio_CD.wav ' + dnm('Audio_CD_',tn2)+ '.wav');
      inc(tn2);
    End;
  If Track = '*' Then
    Begin
      chdir (setup.temp);
      execute ('/usr/bin/cdtux.cdda2wav Audio_CD -q -g -H -B "-D '+ scsi +'"');
    End;
  End;
  If Track[1] = 'D' Then
  Begin
  chdir (setup.temp);
  If Scsi = CDromp Then Scsi := setup.cdromdev else Scsi := setup.CDrDev;
  execute ('dd if=' +scsi  + ' of=' +dnm('Data_Copied_',tn2) + '.trk');
  inc(tn2);
  If exists (dnm('Data',tn)) Then
  Execute ('rm -rf ' + dnm('Data',tn));
  End;
End;

Procedure RipMP3(Track :String);
Begin
  Page.Destruct;
  Writeln ('Please Wait While MP3 Conversion Completes:');
  execute ('cp "' + track + '" ' + pathn + '/Audio.mp3');
  shell ('/usr/bin/mpg123 -s -v ' + pathn + '/Audio.mp3 >'+pathn + '/' +trackn + '.raw');
  Writeln ('Please Wait While Finalising Conversion Process');
  Execute (setup.soxpath + ' -c 2 -s -w -r 44100 ' + pathn + '/'+ trackn + '.raw ' + pathn
           +'/'+trackn + '.wav');
  Execute ('rm -rf '+pathn+'/*.raw');
  Execute ('rm -rf '+pathn+'/*.mp3');
  Page.define(blue,white,white,
              'CD-Tux CD-Writing Frontend. Copyright 1999 AJA Venter. GPL');
  page.headerchng ('CD-Tux Image Definition Screen');
  infoblock (2,11,78,21);
  Writeln('This is where you select the files for your compilation.');
  writeln('Tab Switches Windows, F1 For Help.');
  Writeln('Select Window Commands: Up And Down Arrows: Next/Previous File');
  writeln('                        Enter Select');
  Writeln('Track Window Commands: Up And Down Arrows: Next/Previous File');
  Writeln('                       Del - Delete File from Image');
  Writeln('                       Right Arrow - Create Directory');
  Writeln('                       Enter [On Directory Name] - Change To');
  Writeln('When Done Press Escape');
  selectc := true;
  window (1,2,78,6);
  textbackground (yellow);
  clrscr;
  window (2,3,78,5);
  textbackground (red);
  clrscr;
  textcolor (white);
  Write ('Select Window: ',fullpath);
  window (3,4,78,4);
  textbackground (blue);
  clrscr;

End;


Procedure Selectwindow(Path:String);
Begin
  window (2,3,77,5);
  textbackground (red);
  clrscr;
  textcolor (white);
  Write ('Select Window: ',path);
  window (3,4,76,4);
  textbackground (blue);
  clrscr;
End;




Procedure imagewindow(ptn:String);
Begin
  window (2,7,77,9);
  textbackground (red);
  clrscr;
  textcolor (white);
  Write ('Track Window:' + ptn);
  window (3,8,76,8);
  textbackground (blue);
  clrscr;
End;

Procedure Help;
Var n :integer;
Begin
n := 0;
Assign (T,'/usr/doc/cdtux/online/help.track');
reset (T);
Page.Refresh;
infoblock (2,3,78,23);
readln (T,helpHeader);
Writeln (HelpHeader);
While Not Eof (t) Do
Begin
   inc (N);
   If N < 18  Then
   Begin
   readln (T,Helpline);
   Writeln (Helpline)
   End Else
   Begin
   Write ('---Press Any Key For Next Page---');
   readkey;
   clrscr;
   Writeln(HelpHeader);
   N := 0;
   End;
End;
Writeln ('---Press Any Key To Return To Track Editor---');
Readkey;
  Page.define(blue,white,white,
              'CD-Tux CD-Writing Frontend. Copyright 1999 AJA Venter. GPL');
  page.headerchng ('CD-Tux Image Definition Screen');
  infoblock (2,11,78,21);
  Writeln('This is where you select the files for your compilation.');
  writeln('Tab Switches Windows, F1 For Help');
  Writeln('Select Window Commands: Up And Down Arrows: Next/Previous File');
  writeln('                        Enter Select');
  Writeln('Track Window Commands: Up And Down Arrows: Next/Previous File');
  Writeln('                       Del - Delete File from Image');
  Writeln('                       Right Arrow - Create Directory');
  Writeln('                       Enter [On Directory Name] - Change To');
  Writeln('When Done Press Escape');
  selectwindow(Fullpath);
  imagewindow(Dirname);
  If Selectc  Then
  Begin
  window (1,2,78,6);
  textbackground (yellow);
  clrscr;
  window (2,3,78,5);
  textbackground (red);
  clrscr;
  Selectwindow(Fullpath);
  End Else
  Begin
  window (1,2,78,6);
  textbackground (white);
  clrscr;
  selectwindow(fullpath);
  window(1,6,78,10);
  textbackground(yellow);
  clrscr;
  imagewindow(DIRNAME);
  End;
End;


Procedure imagewindowU;
Begin
  window (1,6,78,10);
  textbackground(white);
  clrscr;
  imagewindow(dirname);
End;


Procedure selectU;
Begin
  window (1,2,78,6);
  textbackground (white);
  clrscr;
  selectwindow(fullpath);
End;


Procedure imagewindowH;

Procedure AddDir;

Var newdir : string;
Begin
  ImageWindow(dirname);
  Write ('Enter Directory Name:');
  Read (NewDir);
  mkdir (newdir);
  ls;
End;

Begin
  selectc := false;
  selectu;
  window(1,6,78,10);
  textbackground(yellow);
  clrscr;
  imagewindow(DIRNAME);
  c := 'a';
  cnt := 1;
  If Data Then
    chdir (pathn + '/' + trackn + dirname)
  Else
    chdir (pathn);
  ls;
  Repeat
    If (Name[cnt] <> '.') And (Name[Cnt] <> '/') And (Name[Cnt] <> '*')
       And (Name[CNT] <> CDROM) And (Name[CNT] <> CDR)
      Then
      Begin
        If (isdir(Name[cnt])) Then
          Write ('[Directory] ',name[cnt])
        Else
          write (name[cnt]);
      End;
    c := readkey;
    Case c Of
      Enter: If Isdir (name[cnt]) Then
               Begin
                 imagewindow(name[cnt]);
                 chdir(name[cnt]);
                 dirname :=  + dirname + name[cnt] + '/';
                 ls;
               End;
      RT_A  : AddDir;
      Up_A : If cnt - 1 >= 1 Then cnt := cnt - 1
             Else cnt := num;
      Pg_UP: If cnt - 10 >= 1 Then cnt := cnt - 10
             Else cnt := 1;
      Dn_A : If cnt + 1 <= num Then inc (cnt)
             Else cnt := 1;
      Pg_Dn: If cnt + 10 <= num Then cnt := cnt + 10
             Else cnt := num;
      Del_bt :
               Begin
                 clrscr;
                 write('Really Remove: ',name[cnt],' [Y/N]?');
                 c := readkey;
                 If (c = 'Y') Or (c = 'y') Then
                   Begin
                     Shell ('rm -rf ' + name[cnt]);
                     ls;
                   End;
               End;
      F1   : Help;
    End;
    clrscr;
  Until (c = tab) Or (c = esc);
  chdir(FULLPATH);
End;

Procedure change2 (Var n : String);
Begin
  Begin
    fullpath :=  fexpand(n) + '/';
    selectwindow (fullpath);
    chdir (n);
    ls;
  End;
End;


Procedure select(path :String);
Begin
If (path = '..') Or (Path = '/') Then CDTrack := False;
  If Not Data Then
    ext := copy(path,length(path) - 3,4);
  If Not CDTRACK Then
    Begin
      If (Path = CDR) Or (Path = CDROM) Then
      Begin
      Imagewindow ('Please Wait While Reading CD TOC');
      Selectwindow (path);
      Readcd(Path);
      Imagewindow ('Done Reading CD TOC');
      Selectwindow (path);
      End
      Else
        Begin
          If (isdir(path)) And (Path <> '*' )Then
            change2(path)
          Else
            Begin
              If (Data) Then
                Execute ('cp "' + path + '" '+ pathn + '/'+  trackn + dirname)
              Else
                Begin
                  If (ext <> '.wav') And (ext <> '.mp3') And (ext <> '.raw') Then
                    execute (setup.soxpath + ' "' + path + '" ' + pathn + '/' + trackn +
                             '.wav');
                  If ext = '.wav' Then
                    execute ('cp "' + path + '" ' + pathn + '/' + trackn + ext);
                  If ext = '.raw' Then
                    execute (setup.soxpath + ' -c 2 -s -w -r 44100 "' + path + '" ' +
                             pathn + '/' + trackn + '.wav');
                  If ext = '.mp3' Then
                    Begin
                      Imagewindow ('Please Wait While Converting MP3 To WAV');
                      ripmp3(path);
                      Imagewindow ('Done Converting.');
                      selectwindow(fullpath);
                    End;

                End;
              Imagewindow('Selected: ' + path);
              selectwindow(fullpath);
            End;
        End;
    End
  Else
    Begin
      Imagewindow ('Please Wait While Ripping CD');
      Selectwindow (path);
      RipCD(Path);
      Imagewindow ('Done Ripping CD');
      Selectwindow (path);
    End;
  UsageMeter;
  window (3,4,77,4);
  textbackground(blue);
End;


Procedure selectH;
Begin
  selectc := true;
  imagewindowU;
  window (1,2,78,6);
  textbackground (yellow);
  clrscr;
  selectwindow(fullpath);
  Ls;
  cnt := 1;
  Repeat
    If (isdir(Name[Cnt])) And (name[cnt] <> '') And (Not CDtrack) Then
      Write ('[Directory] ',name[cnt])
    Else
      write (name[cnt]);
    c := readkey;
    Case C Of
      Up_A : If cnt -1 >= 1 Then cnt := cnt - 1
             Else cnt := num;
      Pg_UP: If cnt - 10 >= 1 Then cnt := cnt - 10
             Else cnt := 1;
      Dn_A : If cnt +1 <= num Then inc (cnt)
             Else cnt := 1;
      Pg_Dn: If cnt + 10 <= num Then cnt := cnt + 10
             Else cnt := num;
      Home : Cnt := 1;
      Enter: select (name[cnt]);
      Space: If name[cnt] = '*' Then       execute('/usr/bin/cdtux.cdda2wav -q -e -N  "-D ' +scsi + '"') Else
      execute('/usr/bin/cdtux.cdda2wav -q -e -d0 -N -t'+ Copy (Name[Cnt],length(Name[Cnt]) - 12,2) + ' "-D ' +scsi + '"');

      F1   : Help;
    End;
    clrscr;
  Until (c = tab) Or (c = esc);
End;

Procedure choosewindow;
Begin
  If selectc Then imagewindowH
  Else selectH;
End;




Begin
  CDTrack := False;
  dirname := '/';
  page.headerchng ('CD-Tux Image Definition Screen: ' + trackn);
  Fullpath := '/';
  If trackn[1] = 'D' Then Data := true
  Else Data := False;
  page.refresh;
  usagemeter;
  infoblock (2,11,78,21);
  clrscr;
  chdir('/');
  num := 1;
  Writeln('This is where you select the files for your compilation.');
  writeln('Tab Switches Windows, F1 For Help');
  Writeln('Select Window Commands: Up And Down Arrows: Next/Previous File');
  writeln('                        Enter Select');
  Writeln('                        Space Select Entire Directory/Preview Play');
  Writeln('Track Window Commands: Up And Down Arrows: Next/Previous File');
  Writeln('                       Del - Delete File from Image');
  Writeln('                       Right Arrow - Create Directory');
  Writeln('                       Enter [On Directory Name] - Change To');
  Writeln('When Done Press Escape');
  selectc := true;
  c := tab;
  num := 1;
  selectH;
  Repeat

    If c = tab Then choosewindow;
  Until c = esc;
End;



Function Speed: string;

Var I,I2 : integer;
    S1,s2: String;
Begin
  Page.Refresh;
  Str ((memavail Div 64000),S1);
  Str (MemAvail Div 1000,S2);
  If Yes ('Suggested Writing Speed :'+ S1+' Use Suggested [Y/N]?')
    Then speed := S1
  Else
    Begin
      Repeat
        I2 := 9;
        Repeat
          Speed := Question ('Enter Speed To Use:');
          Val(Speed,I,I2);
          If I2 <> 0 Then
            Begin
              Page.Refresh;
              Infoblock (2,3,78,5);
              Write ('Please Enter A Number. Press Any Key To Try Again.');
              readkey;
            End;
        Until I2 = 0;
      Until Yes('You Selected ' + Speed + ' Are You Sure [Y/N]?');
    End;
End;

Procedure WriteCD;

Var SPD : String;

Procedure Nodummy;
Begin
  Page.Refresh;
     If Yes('Really Write [Y/N] ?') Then
       Begin
         SPD := Speed;
         If Yes('Close Session (No Further Writing Possible)[Y/N]') Then
           Begin
             Page.Refresh;
             Infoblock (2,3,78,5);
             write('Passing Controll To cdrecord in 3 sec. Press Escape Key To Abort');
             Delay (3000);
             If keypressed Then C := Readkey;
             If c <> esc Then
               Begin
                 Page.Destruct;
                 If (NumA > 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath +' dev= '+cdrp +' -speed='+spd+
                          ' -v -pad -data Data*.* -audio Audio*.*');
                 If (NumA > 0) And (NumD <= 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +' -speed='+spd+
                          ' -v -pad -audio Audio*.*');
                 If (NumA <= 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +'  -speed='+spd+
                          ' -v -data Data*.*');
                 Writeln ('Press Any Key To Return To CD-Tux');
                 c := Readkey;
               End;
           End
         Else
           Begin
             Page.Refresh;
             Infoblock (2,3,78,5);
             write('Passing Controll To cdrecord in 3 sec. Press Escape Key To Abort');
             Delay (3000);
             If keypressed Then c := readkey;
             If c <> esc Then
               Begin
                 Page.Destruct;
                 If (NumA > 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath +' dev= '+cdrp +'  -speed='+spd+
                          ' -multi -pad -v -data Data*.* -audio Audio*.*');
                 If (NumA > 0) And (NumD <= 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +'  -speed='+spd+
                          ' -multi -pad -v -audio Audio*.*');
                 If (NumA <= 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +'  -speed='+spd+
                          ' -multi -v -data Data*.*');
                 Writeln ('Press Any Key To Return To CD-Tux');
                 c := readkey;
               End;
           End;
       End;
End;

Procedure dummy;
Begin
  Page.Refresh;
     If Yes('Proceed With Dummy Write [Y/N] ?') Then
       Begin
         spd := speed;
         If Yes('Close Session (No Further Writing Possible)[Y/N]') Then
           Begin
             Page.Refresh;
             Infoblock (2,3,78,5);
             write('Passing Controll To cdrecord in 3 sec. Press Escape Key To Abort');
             Delay (3000);
             If keypressed Then C := Readkey;
             If c <> esc Then
               Begin
                 Page.Destruct;
                 If (NumA > 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath +' dev= '+cdrp +' -speed='+spd+
                          '  -pad -dummy -v -data Data*.* -audio Audio*.*');
                 If (NumA > 0) And (NumD <= 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +' -speed='+spd+
                          ' -pad -dummy -v -audio Audio*.*');
                 If (NumA <= 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +' -speed='+spd+
                          ' -dummy -v -data Data*.*');
                 Writeln ('Press Any Key To Return To CD-Tux');
                 c := Readkey;
               End;
           End
         Else
           Begin
             Page.Refresh;
             Infoblock (2,3,78,5);
             write('Passing Controll To cdrecord in 3 sec. Press Escape Key To Abort');
             Delay (3000);
             If keypressed Then C := Readkey;
             If c <> esc Then
               Begin
                 Page.Destruct;
                 If (NumA > 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath +' dev= '+cdrp +' -speed='+spd+
                          ' -multi -dummy -v -pad -data Data*.* -audio Audio*.*');
                 If (NumA > 0) And (NumD <= 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +' -speed='+spd+
                          ' -multi -dummy -v -pad -audio Audio*.*');
                 If (NumA <= 0) And (NumD > 0) Then
                   shell (setup.cdrecordpath + ' dev= '+cdrp +' -speed='+spd+
                          ' -multi -dummy -v -data Data*.*');
                 Writeln ('Press Any Key To Return To CD-Tux');
                 c := Readkey;
               End;
           End;
       End;
End;

Begin
  Page.REfresh;
  If Yes('Do A Test Run First[Y/N]') Then
    Begin
      Dummy;
      Page.Refresh;
      If Yes ('Proceed With Real Write[Y/N]') Then
        nodummy;
    End
  Else
    nodummy;
  Page.Refresh;
End;

Procedure BlankTOC;

Var spd : string;
Begin
  Page.Refresh;
  If Yes('Really Blank TOC [Y/N] ?') Then
    Begin
      spd := speed;
      Page.Refresh;
      Infoblock (2,3,78,5);
      Write ('Passing Controll To CD-Record In 3 Sec. Press Escape Key To Abort');
      Delay (3000);
      If Keypressed Then C := Readkey;
      If c <> esc Then
        Begin
          Page.Destruct;
          Shell (setup.cdrecordpath + ' -speed='+spd+' dev='+cdrp + ' -blank=fast');
          Writeln ('Press Any Key To Return To CD-Tux');
          c := readkey;
        End;
    End;
  Page.Refresh;
End;


Procedure BlankFull;

Var spd: string;
Begin
  Page.Refresh;
  If Yes('Really Blank Whole Disk [Y/N] ?') Then
    Begin
      spd := speed;
      Page.Refresh;
      Infoblock (2,3,78,5);
      Write ('Passing Controll To CD-Record In 3 Sec. Press Escape Key To Abort');
      Delay (3000);
      If Keypressed Then C := readkey;
      If C <> Esc Then
        Begin
          Page.Destruct;
          Shell (setup.cdrecordpath + ' -speed='+spd+' dev='+cdrp + ' -blank=all');
          Writeln ('Press Any Key To Return To CD-Tux');
          c := readkey;
        End;
    End;
  Page.Refresh;
End;



Procedure REMTRACK;

Var TRN: String;
Begin
  TRN := Question ('Enter Track Name:');
  If Yes('Really Remove '+trn+' [Y/N]?') Then
    Begin
      execute ('yes|rm -r '+trn);
      If (TRn[1] = 'D') Then
        Begin
          If NumD > 0 Then
            Dec(NumD)
        End
      Else
        Begin
          If NumA > 0 Then
            Dec (NumA);
        End;
    End;
    If TRn = '*' Then tn := 1;
  page.refresh;
End;

Procedure Import;

Begin
  Page.REfresh;
  imported := true;
  Popen (T,setup.cdrecordpath + ' -msinfo -dev='+cdrp,'R');
  While Not EOF (t) Do
  Readln (T,importS);
End;

Procedure EditTrack;
Var Track :String;
Begin
Track := Question ('Enter The Track Name To Edit: (Enter For None)');
If Track <> '' Then
Begin
If track[1] <> 'A' then
Begin
chdir (setup.temp);
mkdir ('Dtemp');
mkdir ('temp');
execute ('mount -t iso9660 -o loop '+ track + ' temp');
execute ('cp temp/* Dtemp');
execute ('umount temp');
execute ('rm -rf temp');
execute ('rm -rf ' + track);
selectfiles (setup.temp,'Dtemp');
Page.Refresh;
Infoblock (2,3,78,22);
chdir (setup.temp);
Write ('Output From mkisofs. Press Any Key When Done');
Execute ('mkisofs -r -R  -o' + track + ' Dtemp');
execute ('rm -rf Dtemp');
Page.Refresh
End Else
Begin
execute ('rm -rf ' + track);
Selectfiles (setup.temp,track);
c := 'z';
End;
End;
End;

Procedure Newtrack;

Var 
  Bootpath : string;
  Bootable : Boolean;
Begin
  Bootable := False;
  Repeat
    page.refresh;
    Infoblock (2,3,78,5);
    If Not Imported Then
      Begin
        Write ('[A]udio Or [D]ata Track ? Escape = Cancel');
        c := readkey;
      End
    Else
      c := 'd';
    page.refresh;
    If (c = 'd') Or (c = 'D') Or (c = 'a') Or (c = 'A') Or (c = esc) Then
      Begin
        If (c = 'd') Or (c = 'D') Then
          Begin
            inc(numD);
            chdir (setup.temp);
            execute ('mkdir ' +  dnm ('Data',tn));
            If (Tn = 1) And Not Imported Then
              Begin
                Page.Refresh;
                Bootable := Yes('Make Disk Bootable [Y/N]');
                If Bootable Then
                  Begin
                    Page.Refresh;
                    BootPath := Question ('Location Of Boot Image:');
                    chdir (dnm('Data',tn));
                    mkdir ('boot');
                    execute ('cp ' + bootpath + '  boot/boot.img');
                  End;
              End;
            With setup Do
              selectfiles (setup.temp,dnm('Data',tn));
            Page.refresh;
            chdir (setup.temp);
            If exists(dnm('Data',tn)) then
            Begin
            Infoblock (2,5,78,25);
            Writeln ('Output From MkIsoFS: (Press Any Key When Done)');
            If Not Imported Then
              Begin
                If (Not Bootable) Then
                  execute (setup.mkisofspath + ' -r -R  -o ' + inm('Data') + ' ' +  dnm(
                                                                                    'Data',tn
                  ))
                Else
                  execute (setup.mkisofspath + ' -b ' + dnm('Data',tn) + '/boot.img -c '+dnm(
                                                                                    'Data',tn
                  ) +'/boot/boot.cat -r -R  -o ' + inm('Data') + ' ' +  dnm('Data',tn));
              End
            Else
              execute (setup.mkisofspath + ' -C '+imports + ' -M ' + setup.cdrdev+
                       ' -r -R  -o ' + inm('Data') + ' ' +  dnm('Data',tn));
            readkey;
            page.refresh;
            run ('rm -rf ' + dnm('Data',tn));
            Bootable := False;
            inc (tn);
            If Imported Then C := esc;
          End;
          End;
        If (c = 'a') Or (c = 'A') Then
          Begin
            Inc(NumA);
            chdir(setup.temp);
            With Setup Do
              selectfiles (setup.temp,dnm('Audio',tn));
            inc(tn);
          End;
      End
    Else
      Begin
        page.refresh;
        Infoblock (2,2,78,4);
        Write ('Sorry Invalid Choice. Press Any Key To Try Again.');
        readkey;
        Page.Refresh;
      End;
  Until (c = esc) Or (c = 'A') Or (c = 'a') Or (c = 'd') Or (c = 'D');
  c := 'z';
End;

Procedure EditImage;
Procedure Help;
Var N :integer;
Begin
n := 0;
Assign (T,'/usr/doc/cdtux/online/help.image');
reset (T);
Page.Refresh;
infoblock (2,3,78,23);
readln (T,helpHeader);
Writeln (HelpHeader);
While Not Eof (t) Do
Begin
   inc (N);
   If N < 18  Then
   Begin
   readln (T,Helpline);
   Writeln (Helpline)
   End Else
   Begin
   Write ('---Press Any Key For Next Page---');
   readkey;
   clrscr;
   Writeln(HelpHeader);
   N := 1;
   End;
End;
Writeln ('---Press Any Key To Return To The Image Editor---');
readkey;
    Page.Refresh;
    UsageMeter;
    infoblock(2,3,78,22);
    Writeln ('Current Tracks:  F1 For Help.');
    Writeln ('[Del]lete Track, [A]dd Track, [E]dit Track, [W]rite Disk Or [Esc]ape ?');
End;



Begin
  Repeat
  PAGE.rEFRESH;
    UsageMeter;
    infoblock(2,3,78,22);
    Writeln ('Current Tracks:  F1 For Help.');
    Writeln ('[Del]lete Track, [A]dd Track, [E]dit Track, [W]rite Disk Or [Esc]ape ?');
    chdir (setup.temp);
    run ('ls -a ');
    c := readkey;
    Case C Of
      'a' : NewTrack;
      'e' : EditTrack;
      'E' : EditTrack;
      'A' : Newtrack;
      'w' : WriteCD;
      'W' : WriteCD;
      F1  : Help;
      Del_bt: RemTrack;
    End;
  Until c = esc;
  Page.refresh;
  If Yes('Save Disk Image [Y/N]') Then
    Begin
      Page.Refresh;
      savedir := Question ('Enter A Name For The Saved Image:');
      execute ('rm -rf ' + savedir);
      execute ('mv ' + setup.temp + ' ' + savedir);
    End
  Else
    Begin
    End;
  Page.Refresh;
End;

Procedure UseSaved;
Var Track :String;
Begin
  Page.Refresh;
  Track := Question('Enter The Name Of The Saved Image:');
  Page.Refresh;
  If Yes('Was This Image Created By CD-Tux [Y/N] ?') Then
  Begin
  If Yes ('Does This Image Contain Data Tracks [Y/N] ?') Then NumD := 1;
  If Yes ('Does This Image Contain Audio Tracks [Y/N] ?') Then NumA := 1;
  execute ('mv '+track + ' setup.temp');
  EditImage;
  execute ('mv setup.temp ' + track);
  End Else
  Begin
  If Yes('Is This A Pure Iso Image [Y/N] ?') Then
  Begin
  execute ('mv ' +track + ' setup.temp/' + dnm('Data_Saved_',tn));
  inc(tn);
  end Else
  Begin
  Setup.Temp := Track;
  If Yes ('Does This Image Contain Data Tracks [Y/N] ?') Then NumD := 1;
  If Yes ('Does This Image Contain Audio Tracks [Y/N] ?') Then NumA := 1;
  WriteCD;
  End;
End;

End;

Begin
  If (Getuid = 0) Then
    Begin
      Page.define(blue,white,white,
                  'CD-Tux CD-Writing Frontend. Copyright 1999 AJA Venter. GPL');
      copyright;

      tn := 1;
      tn2 := 1;
{$I-}
If not ReadSetupFile(Setup) Then
        Begin
        Page.Refresh;
        Infoblock (2,3,78,5);
        Write ('No Configuration File Was Found. Press Any Key To Run cdtuxsetup');
        readkey;
        page.destruct;
        shell ('cdtuxsetup');
        halt;
        End Else
{RDSetupFile (Setup);}
      With Setup Do
        Begin
          cdrp := cdrBus + ',' + cdrID + ',' + cdrLun;
          cdromp := cdromBus + ',' + cdromID + ',' + cdromLun;
        End;
{$I+}
      imported := false;
      page.refresh;
      Repeat
        c := 'a';
        Page.refresh;
        Infoblock (2,3,78,15);
        Writeln ('CD-Tux Main Menu');
        Writeln ('A      > New Disk Image');
        Writeln ('B      > Saved Image');
        Writeln ('C      > Blank CD-RW Table Of Contents Only');
        Writeln ('D      > Full Blank CD-RW (May Take A While');
        If (NumA = 0) And (NumD = 0) Then
        Writeln ('E      > Import MultiSession');
        Writeln ('F1     > Help');
        writeln ('Escape > Quit');
        c := readkey;
        Case c Of
          'a' : EditImage;
          'A' : EditImage;
          'B' : UseSaved;
          'b' : UseSaved;
          'c' : BlankTOC;
          'C' : BlankTOC;
          'd' : BlankFull;
          'D' : BlankFull;
          'e' : Import;
          'E' : Import;
          F1  : help;
        End;
      Until (c = esc);
      If (NumA > 0) Or (NumD > 0) Then
        Begin
          readsetupfile (setup);
          execute ('rm -rf '+setup.temp);
          mkdir (setup.temp);
        End;
      Page.Destruct;
    End
  Else
    Begin
      Writeln ('Sorry This Program Can Only Be Run By root. ');
      Writeln ('On Some Systems It Will Be Sufficient To Run With SUID root');
      Writeln ('However I Do Not Recommend This.');
    End;
End.
