# Note that this is NOT a relocatable package
# defaults for redhat

%define prefix		/usr

Summary: ECLiPt Roaster
Name: eroaster
Version: 2.0b4
Release: 1
Copyright: GPL
Group: Applications/Internet
URL: http://eclipt.uni-klu.ac.at
Source: ftp://eclipt.uni-klu.ac.at/pub/projects/%{name}/%{name}-%{version}.tar.gz
Packager: Martin Preishuber <Martin.Preishuber@stuco.uni-klu.ac.at>
BuildArchitectures: noarch
BuildRoot: /var/tmp/%{name}-%{version}-root
Requires: python pygtk pygnome pygnome-applet cdrecord cdrecord-mkisofs

%description

%prep

%setup 
./configure --prefix=%{prefix}

%build

%install
make prefix=$RPM_BUILD_ROOT/%{prefix} install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{prefix}/bin/eroaster
%{prefix}/share/eroaster/pixmaps/*
%{prefix}/lib/eroaster/*

%doc COPYING ChangeLog INSTALL THANKS TODO

%changelog
* Mon Jul 10 2000 Martin Preishuber <Martin.Preishuber@eclipt.uni-klu.ac.at>
- [2.0b4-1]
* Sun Feb 06 2000 Martin Preishuber <Martin.Preishuber@stuco.uni-klu.ac.at>
- [1.99a-1]
* Tue Jan 25 2000 Martin Preishuber <Martin.Preishuber@stuco.uni-klu.ac.at>
- [1.99-2]
  added cdrecord and cdrecord-mkisofs to the requirements
* Tue Jan 25 2000 Martin Preishuber <Martin.Preishuber@stuco.uni-klu.ac.at>
- [initial spec]
