#include <string>

class CDTools
{
public:	
    CDTools(string aDevice = "", string aMountpoint = "");
    void setMountpoint(string aMountpoint);
    void setDevice(string aDevice);
    int  isOpen();
    int  close();
    int  open();
    int  toggleOpen();
    int  getInfo();
private:
    string device;
    string mountpoint;
    bool   use_cdctl;
    bool   use_eject;
    bool   shouldBeOpen;
    int    doSystemCall(string cmdline);
};
