#ifndef Opt_cddoc_included
#define Opt_cddoc_included

/*** Qt ***/
#include <qlineedit.h>
#include <qdialog.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>

/*** KDE ***/
#include <ksimpleconfig.h>

/*** C++ ***/

/*** KisoCD ***/
#include "types.h"
#include "switches.h"

class Opt_cddoc : public QDialog
{
    Q_OBJECT

private:
    KSimpleConfig*    globalConf;
    T_SysOptions*     sysOpts;

  /***** cdDoc **********/
  QLabel*       labelLatex;
  QLabel*       labelView;
  QLabel*       labelPrint;
  QLabel*       labelEdit;

  QLineEdit*  leView;
  QLineEdit*  lePrint;
  QLineEdit*  leLatex;
  QLineEdit*  leEdit; 
public:
  Opt_cddoc(QWidget*       parent,
	    const char*    name,
	    KSimpleConfig* globConf,
	    T_SysOptions*  sysOptions);
  ~Opt_cddoc();
    

protected:
    /***** allgemein *********/
    QPushButton*   buttonCancel;
    QPushButton*   buttonApply;
    QPushButton*   buttonOK;
    /******* device ***********/

protected slots:
  void applySettings();
  void ok_clicked(); 
};

#endif // Opt_cddoc_included






