#ifndef Opt_ui_included
#define Opt_ui_included

/*** Qt ***/
#include <qdialog.h>
#include <qwidget.h>
#include <qcheckbox.h>
#include <qpushbutton.h>

/*** KDE ***/
#include <ksimpleconfig.h>

/*** C++ ***/

/*** KisoCD ***/
#include "types.h"
#include "switches.h"

class Opt_ui : public QDialog
{
    Q_OBJECT

private:
    KSimpleConfig*    globalConf;
    T_SysOptions*     sysOpts;

  QCheckBox*       cb_OptOnStartup;
  QCheckBox*       cb_ProcFinMsg;
  QCheckBox*       cb_ProcWinOnStart;
  QCheckBox*       cb_SimpleDND;
public:
  Opt_ui(QWidget*       parent,
	    const char*    name,
	    KSimpleConfig* globConf,
	    T_SysOptions*  sysOptions);
  ~Opt_ui();
    

protected:
    /***** allgemein *********/
    QPushButton*   buttonCancel;
    QPushButton*   buttonApply;
    QPushButton*   buttonOK;

protected slots:
  void applySettings();
  void ok_clicked(); 
};

#endif // Opt_ui_included






