#ifndef __optionsXY__HEADERDAT
#define __optionsXY__HEADERDAT

/*** Qt ***/
#include <qstring.h>
#include <qmessagebox.h>

/*** KDE ***/
#include <ksimpleconfig.h>

/*** C++ ***/
#include <string>

/*** KisoCD ***/
#include "version.h"
#include "types.h"
#include "tools.h"
#include "switches.h"

void saveOptions(struct T_Options      &defOpts, 
		 struct T_SysOptions   &sysOpts,
		 string                HeimatPfad);
void setDefaultConfig(struct T_Options      &defOpts, 
		      struct T_SysOptions   &sysOpts,
		      string                HeimatPfad);
int ladeVorgaben(KSimpleConfig*        globalConf,
		 string                HeimatPfad,
		 struct T_Options      &defOpts, 
		 struct T_SysOptions   &sysOpts);

void readStringEntry(KSimpleConfig*   confDat,
		     const char*      name,
   		     string           &value);
void readNumEntry   (KSimpleConfig*   confDat,
	             const char*      name,
	             int              &value);
void readBoolEntry  (KSimpleConfig*   confDat,
		     const char*      name,
		     bool             &value);

#endif  // __optionsXY__HEADERDAT


















