#ifndef typen_header_H
#define typen_header_H

#include <string>

struct T_Options {     // Diese Optionen werden pro Datei eingestellt, knnen aber
  bool switches[9];    // systemweite Voreinstellungen haben.

  string   IDdisc;
  string   IDvolume;
  string   IDpreparer;
  string   IDpublisher;

  bool     fCreateImage;
  bool     fDummyWrite;
  bool     fPadTrack;
  
  bool     fbootCD;
  string   bootImagePath;

  bool     fMulti;
  bool     fMultiFirstSess;
  bool     fMultiLastSess;

  bool     fCopyDataCD;
};

struct T_SysOptions {   // Einstellungen, die "ber alles" eingestellt 
  string   latexCmd;    // werden und nicht pro Datei.
  string   viewCmd;
  string   printCmd;
  string   editorCmd;
  bool     fAutoCompile;

  string   writeDeviceSFile;
  string   writeDevice;
  string   mountPoint;
  string   readDevice;

  string   imageFilePath;    
  string   tmpDir;
  int      nFifoSize;         
  int      nWritingSpeedImg; 
  int      nWritingSpeedOTF;
  int      nBlankingSpeed;
  string   availSpeed;

  bool     fEject;
  bool     fShutdown;

  /* User Interface */
  bool     fSimpleDND;
  bool     fOptOnStartup;
  bool     fProcFinMsg;
  bool     fProcWinOnStart;
};

#endif // typen_header_H











