#include <krabwidget.h>
#include <kapp.h>

void KrabWidget::initLayout(void) {
	QString temp;

	KTabListBox_todo      = new KTabListBox( this, "KTabListBox_todo" );
	QFrame_controll       = new QFrame ( this, "QFrame_controll");
	QGroupBox_encoder     = new QGroupBox ( QFrame_controll, "QGroupBox_encoder");
	QGroupBox_opt2        = new QGroupBox ( QFrame_controll, "QGroupBox_opt2");
 	QGroupBox_options     = new QGroupBox ( QFrame_controll, "QGroupBox_options");
	QGroupBox_nice        = new QGroupBox ( QFrame_controll, "QGroupBox_nice");
	QGroupBox_cache       = new QGroupBox ( QFrame_controll, "QGroupBox1");
	QGroupBox_cddb        = new QGroupBox ( QFrame_controll, "QGroupBox2");

	QComboBox_encoder     	= new KComboExt ( QGroupBox_encoder, "");
	QCheckBox_q_resample  	= new QCheckBox ( QGroupBox_opt2, "QCheckBox_quality_resample");
	QCheckBox_jitter      	= new QCheckBox ( QGroupBox_opt2, "QCheckBox_cdda_jitter");
	QComboBox_device      	= new QComboBox ( QGroupBox_opt2, "QComboBox_device");
	QCheckBox_mp3_header  	= new QCheckBox ( QGroupBox_opt2, "QCheckBox_mp3_header");
	QCheckBox_tempfiles    	= new QCheckBox ( QGroupBox_opt2, "QCheckBox_tempfiles");
	QCheckBox_clear_list   	= new QCheckBox ( QGroupBox_opt2, "QCheckBox_clear_list");
	QLabel_smp            	= new QLabel( QGroupBox_nice, "" );
	QLabel_nice           	= new QLabel( QGroupBox_nice, "" );
	KSlider_nice          	= new KSlider ( 0 , 19, 1, 19, KSlider::Horizontal,  QGroupBox_nice, "");
	KSlider_smp           	= new KSlider ( 1 , MAX_ENCODERS, 1, 1, KSlider::Horizontal,  QGroupBox_nice, "");
	QPushButton_outputpath	= new QPushButton ( QGroupBox_cache, "QPushButton_outputpath" );
	QPushButton_names     	= new QPushButton ( QGroupBox_cache, "QPushButton_names" );
 	QPushButton_cd        	= new QPushButton ( QGroupBox_cache , "");
 	QPushButton_doit      	= new QPushButton ( QGroupBox_cache ,"");
 	QPushButton_cddb_get  	= new QPushButton ( QGroupBox_cddb , "");
 	QPushButton_cddb_send 	= new QPushButton ( QGroupBox_cddb , "");

	this->setCaption( "" );
	this->setGeometry( 536, 480, 677, 432 );
	this->setMinimumSize( 0, 0 );
	this->setMaximumSize( 32767, 32767 );
	this->setMouseTracking( FALSE);
	this->setSizeIncrement( 0, 0 );

	KTabListBox_todo->setCaption( "" );
	KTabListBox_todo->setGeometry( 4, 4, 365, 421 );
	KTabListBox_todo->setMinimumSize( 0, 0 );
	KTabListBox_todo->setMaximumSize( 32767, 32767 );
	KTabListBox_todo->setNumCols( 9 );
	KTabListBox_todo->setColumn( 0, "", 40, KTabListBox::PixmapColumn );
	KTabListBox_todo->setColumn( 1, i18n( "Nr." ), 25 );
	KTabListBox_todo->setColumn( 2, i18n( "Track" ), 38 );
	KTabListBox_todo->setColumn( 3, i18n( "Input" ), 150 );
	temp = i18n( "Size" ); temp += "(kB)";
	KTabListBox_todo->setColumn( 4, temp, 60 );
	KTabListBox_todo->setColumn( 5, i18n( "Interpret" ), 100 );
	KTabListBox_todo->setColumn( 6, i18n( "Album" ), 100 );
	KTabListBox_todo->setColumn( 7, i18n( "Title" ), 150 );
	KTabListBox_todo->setColumn( 8, i18n( "Output filename" ), 200 );
	KTabListBox_todo->setSizeIncrement( 0, 0 );
	KTabListBox_todo->setCurrentItem( -1 );
	KTabListBox_todo->setTopItem( 0 );

	QFrame_controll->setCaption( "" );
	QFrame_controll->setGeometry( 376, 4, 297, 421 );
	QFrame_controll->setMinimumSize( 297, 421 );
	QFrame_controll->setMaximumSize( 297, 421 );
	QFrame_controll->setMouseTracking( FALSE);
	QFrame_controll->setSizeIncrement( 0, 0 );
	QFrame_controll->setLineWidth( 1 );
	QFrame_controll->setMidLineWidth( 0 );
	QFrame_controll->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QGroupBox_encoder->setCaption( "" );
	QGroupBox_encoder->setGeometry( 8, 8, 129, 120 );
	QGroupBox_encoder->setMouseTracking( FALSE);
	QGroupBox_encoder->setSizeIncrement( 0, 0 );
	QGroupBox_encoder->setLineWidth( 1 );
	QGroupBox_encoder->setMidLineWidth( 0 );
	QGroupBox_encoder->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_encoder->setTitle( i18n ( "Format" ) );
	QGroupBox_encoder->setAlignment( AlignLeft );

	QComboBox_encoder->setCaption( "" );
	QComboBox_encoder->setGeometry( 8, 20, 113, 29 );
	QComboBox_encoder->setMouseTracking( FALSE);
	QComboBox_encoder->setSizeIncrement( 0, 0 );
	QComboBox_encoder->setAutoResize( FALSE );

	QGroupBox_opt2->setCaption( "" );
	QGroupBox_opt2->setGeometry( 144, 8, 145, 155 );
	QGroupBox_opt2->setMouseTracking( FALSE);
	QGroupBox_opt2->setSizeIncrement( 0, 0 );
	QGroupBox_opt2->setLineWidth( 1 );
	QGroupBox_opt2->setMidLineWidth( 0 );
	QGroupBox_opt2->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_opt2->setTitle( i18n ("Generic Options" ));
	QGroupBox_opt2->setAlignment( AlignLeft );

	QCheckBox_q_resample->setCaption( "" );
	QCheckBox_q_resample->setGeometry( 8, 48, 132, 20 );
	QCheckBox_q_resample->setMouseTracking( FALSE);
	QCheckBox_q_resample->setSizeIncrement( 0, 0 );
	QCheckBox_q_resample->setText( i18n( "Quality Resample" ) );
	QCheckBox_q_resample->setAutoResize( FALSE );
	QCheckBox_q_resample->setAutoRepeat( FALSE );

	QCheckBox_mp3_header->setCaption( "" );
	QCheckBox_mp3_header->setGeometry( 8, 68, 132, 20 );
	QCheckBox_mp3_header->setMouseTracking( FALSE);
	QCheckBox_mp3_header->setSizeIncrement( 0, 0 );
	QCheckBox_mp3_header->setText( i18n ( "create mp3 tag" ) );
	QCheckBox_mp3_header->setAutoResize( FALSE );
	QCheckBox_mp3_header->setAutoRepeat( FALSE );

	QCheckBox_jitter->setCaption( "" );
	QCheckBox_jitter->setGeometry( 8, 88, 132, 20 );
	QCheckBox_jitter->setMouseTracking( FALSE);
	QCheckBox_jitter->setSizeIncrement( 0, 0 );
	QCheckBox_jitter->setText( i18n ( "Jitter filter" ) );
	QCheckBox_jitter->setAutoResize( FALSE );
	QCheckBox_jitter->setAutoRepeat( FALSE );

	QCheckBox_tempfiles->setCaption( "" );
	QCheckBox_tempfiles->setGeometry( 8, 108, 132, 20 );
	QCheckBox_tempfiles->setMouseTracking( FALSE);
	QCheckBox_tempfiles->setSizeIncrement( 0, 0 );
	QCheckBox_tempfiles->setText( i18n( "direct convert" ) );
	QCheckBox_tempfiles->setAutoResize( FALSE );
	QCheckBox_tempfiles->setAutoRepeat( FALSE );

	QCheckBox_clear_list->setCaption( "" );
	QCheckBox_clear_list->setGeometry( 8, 128, 132, 20 );
	QCheckBox_clear_list->setMouseTracking( FALSE);
	QCheckBox_clear_list->setSizeIncrement( 0, 0 );
	QCheckBox_clear_list->setText( i18n( "autodelete entrys" ) );
	QCheckBox_clear_list->setAutoResize( FALSE );
	QCheckBox_clear_list->setAutoRepeat( FALSE );

	QComboBox_device->setCaption( "" );
	QComboBox_device->setGeometry( 8, 16, 129, 29 );
	QComboBox_device->setMouseTracking( FALSE);
	QComboBox_device->setSizeIncrement( 0, 0 );
	QComboBox_device->setSizeLimit( 10 );
	QComboBox_device->setMaxCount( 2147483647 );
	QComboBox_device->setAutoResize( FALSE );
	QComboBox_device->setInsertionPolicy( QComboBox::AtBottom );

	QGroupBox_options->setCaption( "" );
	QGroupBox_options->setGeometry( 8, 128, 129, 188 );
	QGroupBox_options->setMouseTracking( FALSE);
	QGroupBox_options->setSizeIncrement( 0, 0 );
	QGroupBox_options->setLineWidth( 1 );
	QGroupBox_options->setMidLineWidth( 0 );
	QGroupBox_options->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_options->setTitle( i18n ( "Options" ) );
	QGroupBox_options->setAlignment( AlignLeft );

	QGroupBox_nice->setCaption( "" );
	QGroupBox_nice->setGeometry( 8, 322, 129, 91 );
	QGroupBox_nice->setMouseTracking( FALSE);
	QGroupBox_nice->setSizeIncrement( 0, 0 );
	QGroupBox_nice->setLineWidth( 1 );
	QGroupBox_nice->setMidLineWidth( 0 );
	QGroupBox_nice->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_nice->setAlignment( AlignLeft );

	KSlider_nice->setCaption( "" );
	KSlider_nice->setGeometry( 8, 5, 113, 24 );

	KSlider_smp->setCaption( "" );
	KSlider_smp->setGeometry( 8, 48, 113, 24 );

	QLabel_nice->setGeometry( 8, 25, 113, 20 );
	QLabel_nice->setText( i18n ( "-   CPU  Priority   +") );
        QLabel_nice->setAlignment( 289 );
        QLabel_nice->setMargin( -1 );

	QLabel_smp->setGeometry( 8, 67, 116, 20 );
	QLabel_smp->setText( i18n ( "1  Nr. of encoders  6") );
        QLabel_smp->setAlignment( 289 );
        QLabel_smp->setMargin( -1 );

	QGroupBox_cache->setCaption( "" );
	QGroupBox_cache->setGeometry( 144, 252, 145, 161 );
	QGroupBox_cache->setMouseTracking( FALSE);
	QGroupBox_cache->setSizeIncrement( 0, 0 );
	QGroupBox_cache->setLineWidth( 1 );
	QGroupBox_cache->setMidLineWidth( 0 );
	QGroupBox_cache->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_cache->setAlignment( AlignLeft );
	
	QPushButton_cd->setCaption( "" );
	QPushButton_cd->setGeometry( 8, 8, 129, 33 );
	QPushButton_cd->setMouseTracking( FALSE);
	QPushButton_cd->setSizeIncrement( 0, 0 );
	QPushButton_cd->setText( "CD" );
	QPushButton_cd->setAutoResize( FALSE );
	QPushButton_cd->setAutoRepeat( FALSE );
	QPushButton_cd->setToggleButton( FALSE );
	QPushButton_cd->setAutoDefault( FALSE );
	QPushButton_cd->setPixmap( *pix_push_1 );

	QPushButton_outputpath->setCaption( "" );
	QPushButton_outputpath->setGeometry( 8, 46, 129, 33 );
	QPushButton_outputpath->setMouseTracking( FALSE);
	QPushButton_outputpath->setSizeIncrement( 0, 0 );
	QPushButton_outputpath->setText( i18n ( "Output Path" ) );
	QPushButton_outputpath->setAutoResize( FALSE );
	QPushButton_outputpath->setAutoRepeat( FALSE );
	QPushButton_outputpath->setToggleButton( FALSE );
	QPushButton_outputpath->setAutoDefault( FALSE );
	QPushButton_outputpath->setPixmap( *pix_push_2 );

	QPushButton_names->setCaption( "" );
	QPushButton_names->setGeometry( 8, 84, 129, 33 );
	QPushButton_names->setMouseTracking( FALSE);
	QPushButton_names->setSizeIncrement( 0, 0 );
	QPushButton_names->setText( i18n ( "Titles" ));
	QPushButton_names->setAutoResize( FALSE );
	QPushButton_names->setAutoRepeat( FALSE );
	QPushButton_names->setToggleButton( FALSE );
	QPushButton_names->setAutoDefault( FALSE );
	QPushButton_names->setPixmap( *pix_push_3 );

	QPushButton_doit->setCaption( "" );
	QPushButton_doit->setGeometry( 8, 122, 129, 33 );
	QPushButton_doit->setMouseTracking( FALSE);
	QPushButton_doit->setSizeIncrement( 0, 0 );
	QPushButton_doit->setText( i18n( "DO IT" ) );
	QPushButton_doit->setAutoResize( FALSE );
	QPushButton_doit->setAutoRepeat( FALSE );
	QPushButton_doit->setToggleButton( FALSE );
	QPushButton_doit->setAutoDefault( FALSE );
	QPushButton_doit->setPixmap( *pix_push_4 );

	QGroupBox_cddb->setCaption( "" );
	QGroupBox_cddb->setGeometry( 144, 168, 145, 80 );
	QGroupBox_cddb->setMouseTracking( FALSE);
	QGroupBox_cddb->setSizeIncrement( 0, 0 );
	QGroupBox_cddb->setLineWidth( 1 );
	QGroupBox_cddb->setMidLineWidth( 0 );
	QGroupBox_cddb->setFrameStyle( QFrame::Box | QFrame::Sunken );
	QGroupBox_cddb->setAlignment( AlignLeft );

	QPushButton_cddb_get->setCaption( "" );
	QPushButton_cddb_get->setGeometry( 8, 5, 129, 33 );
	QPushButton_cddb_get->setMouseTracking( FALSE);
	QPushButton_cddb_get->setSizeIncrement( 0, 0 );
	QPushButton_cddb_get->setText( i18n( "ask CDDB server" ) );
	QPushButton_cddb_get->setAutoResize( FALSE );
	QPushButton_cddb_get->setAutoRepeat( FALSE );
	QPushButton_cddb_get->setToggleButton( TRUE );
	QPushButton_cddb_get->setAutoDefault( FALSE );
	QPushButton_cddb_get->setPixmap( *pix_push_5 );

	QPushButton_cddb_send->setCaption( "" );
	QPushButton_cddb_send->setGeometry( 8, 42, 129, 33 );
	QPushButton_cddb_send->setMouseTracking( FALSE);
	QPushButton_cddb_send->setSizeIncrement( 0, 0 );
	QPushButton_cddb_send->setText( i18n ( "send CDDB data" ) );
	QPushButton_cddb_send->setAutoResize( FALSE );
	QPushButton_cddb_send->setAutoRepeat( FALSE );
	QPushButton_cddb_send->setToggleButton( TRUE );
	QPushButton_cddb_send->setAutoDefault( FALSE );
	QPushButton_cddb_send->setPixmap( *pix_push_6 );


// Sometimes hidden:
	QCheckBox_stereo = new QCheckBox ( QGroupBox_options, "QCheckBox_cdda_stereo");
	QCheckBox_16bit = new QCheckBox ( QGroupBox_options, "QCheckBox_cdda_16bit");
	QComboBox_bitrate 	= new QComboBox ( QGroupBox_encoder, "QComboBox_bitrate" );
	QLineEdit_bitrate_other	= new QLineEdit ( QGroupBox_encoder, "QLineEdit_bitrate_other" );

	QCheckBox_stereo->setCaption( "" );
	QCheckBox_stereo->setGeometry( 10, 160, 61, 29 );
	QCheckBox_stereo->setMouseTracking( FALSE);
	QCheckBox_stereo->setSizeIncrement( 0, 0 );
	QCheckBox_stereo->setText( "Stereo" );
	QCheckBox_stereo->setAutoResize( FALSE );
	QCheckBox_stereo->setAutoRepeat( FALSE );
	QCheckBox_stereo->hide();
	connect( QCheckBox_stereo, SIGNAL(toggled(bool)), SLOT(todolist_update(bool)) );

	QCheckBox_16bit->setCaption( "" );
	QCheckBox_16bit->setGeometry( 10, 187, 61, 29 );
	QCheckBox_16bit->setMouseTracking( FALSE);
	QCheckBox_16bit->setSizeIncrement( 0, 0 );
	QCheckBox_16bit->setText( i18n ( "16bit" ) );
	QCheckBox_16bit->setAutoResize( FALSE );
	QCheckBox_16bit->setAutoRepeat( FALSE );
	QCheckBox_16bit->hide();
	connect( QCheckBox_16bit, SIGNAL(toggled(bool)), SLOT(todolist_update(bool)) );

	QComboBox_bitrate->setCaption( "" );
	QComboBox_bitrate->setGeometry( 8, 52, 113, 29 );
	QComboBox_bitrate->setMouseTracking( FALSE);
	QComboBox_bitrate->setSizeIncrement( 0, 0 );
	QComboBox_bitrate->setSizeLimit( 10 );
	QComboBox_bitrate->setMaxCount( 2147483647 );
	QComboBox_bitrate->setAutoResize( FALSE );
	QComboBox_bitrate->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
//	QComboBox_bitrate->hide();
	connect( QComboBox_bitrate, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QLineEdit_bitrate_other->setGeometry( 8, 84, 113, 29 );
	QLineEdit_bitrate_other->setMaxLength( 5 );
	QLineEdit_bitrate_other->setText( "44100" );
	QIntValidator *v = new QIntValidator( 1, 50000, this );
	QLineEdit_bitrate_other->setValidator( (QValidator*) v );
	QLineEdit_bitrate_other->hide();
	connect( QLineEdit_bitrate_other, SIGNAL(returnPressed()), SLOT(todolist_update()) );
};

void KrabWidget::initLayout_8hz()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_8hz_br = new QComboBox ( QGroupBox_options, "QComboBox_8hz_br" );
	QCheckBox_8hz_copyright = new QCheckBox ( QGroupBox_options, "QCheckBox_8hz_copyright");
	QCheckBox_8hz_original = new QCheckBox ( QGroupBox_options, "QCheckBox_8hz_original");

	QComboBox_8hz_br->setCaption( "" );
	QComboBox_8hz_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_8hz_br->setMinimumSize( 0, 0 );
	QComboBox_8hz_br->setMaximumSize( 32767, 32767 );
	QComboBox_8hz_br->setMouseTracking( FALSE);
	QComboBox_8hz_br->setSizeIncrement( 0, 0 );
	QComboBox_8hz_br->setSizeLimit( 10 );
	QComboBox_8hz_br->setMaxCount( 2147483647 );
	QComboBox_8hz_br->setAutoResize( FALSE );
	QComboBox_8hz_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_8hz_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_8hz[i] );
		temp = "";
		if ( bitrate_8hz[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_8hz_br->insertItem( temp );
	};
	QComboBox_8hz_br->show();
	connect( QComboBox_8hz_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QCheckBox_8hz_copyright->setCaption( "" );
	QCheckBox_8hz_copyright->setGeometry( 8, 50, 113, 29 );
	QCheckBox_8hz_copyright->setMinimumSize( 0, 0 );
	QCheckBox_8hz_copyright->setMaximumSize( 32767, 32767 );
	QCheckBox_8hz_copyright->setMouseTracking( FALSE);
	QCheckBox_8hz_copyright->setSizeIncrement( 0, 0 );
	QCheckBox_8hz_copyright->setText( i18n ( "copyright" ) );
	QCheckBox_8hz_copyright->setAutoResize( FALSE );
	QCheckBox_8hz_copyright->setAutoRepeat( FALSE );
	QCheckBox_8hz_copyright->show();

	QCheckBox_8hz_original->setCaption( "" );
	QCheckBox_8hz_original->setGeometry( 8, 75, 113, 29 );
	QCheckBox_8hz_original->setMinimumSize( 0, 0 );
	QCheckBox_8hz_original->setMaximumSize( 32767, 32767 );
	QCheckBox_8hz_original->setMouseTracking( FALSE);
	QCheckBox_8hz_original->setSizeIncrement( 0, 0 );
	QCheckBox_8hz_original->setText( i18n ( "original" ) );
	QCheckBox_8hz_original->setAutoResize( FALSE );
	QCheckBox_8hz_original->setAutoRepeat( FALSE );
	QCheckBox_8hz_original->show();

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "32000" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
};
void KrabWidget::initLayout_blade()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_blade_br = new QComboBox ( QGroupBox_options, "QComboBox_blade_br" );
	QCheckBox_blade_copyright = new QCheckBox ( QGroupBox_options, "QCheckBox_blade_copyright");
	QCheckBox_blade_private = new QCheckBox ( QGroupBox_options, "QCheckBox_blade_private");
	QCheckBox_blade_crc = new QCheckBox ( QGroupBox_options, "QCheckBox_blade_crc");

	QComboBox_blade_br->setCaption( "" );
	QComboBox_blade_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_blade_br->setMinimumSize( 0, 0 );
	QComboBox_blade_br->setMaximumSize( 32767, 32767 );
	QComboBox_blade_br->setMouseTracking( FALSE);
	QComboBox_blade_br->setSizeIncrement( 0, 0 );
	QComboBox_blade_br->setSizeLimit( 10 );
	QComboBox_blade_br->setMaxCount( 2147483647 );
	QComboBox_blade_br->setAutoResize( FALSE );
	QComboBox_blade_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_blade_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_blade[i] );
		temp = "";
		if ( bitrate_blade[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_blade_br->insertItem( temp );
	};
	QComboBox_blade_br->show();
	connect( QComboBox_blade_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QCheckBox_blade_copyright->setCaption( "" );
	QCheckBox_blade_copyright->setGeometry( 8, 50, 113, 29 );
	QCheckBox_blade_copyright->setMinimumSize( 0, 0 );
	QCheckBox_blade_copyright->setMaximumSize( 32767, 32767 );
	QCheckBox_blade_copyright->setMouseTracking( FALSE);
	QCheckBox_blade_copyright->setSizeIncrement( 0, 0 );
	QCheckBox_blade_copyright->setText( i18n ( "copyright" ) );
	QCheckBox_blade_copyright->setAutoResize( FALSE );
	QCheckBox_blade_copyright->setAutoRepeat( FALSE );
	QCheckBox_blade_copyright->show();

	QCheckBox_blade_private->setCaption( "" );
	QCheckBox_blade_private->setGeometry( 8, 75, 113, 29 );
	QCheckBox_blade_private->setMinimumSize( 0, 0 );
	QCheckBox_blade_private->setMaximumSize( 32767, 32767 );
	QCheckBox_blade_private->setMouseTracking( FALSE);
	QCheckBox_blade_private->setSizeIncrement( 0, 0 );
	QCheckBox_blade_private->setText( i18n ( "private" ) );
	QCheckBox_blade_private->setAutoResize( FALSE );
	QCheckBox_blade_private->setAutoRepeat( FALSE );
	QCheckBox_blade_private->show();

	QCheckBox_blade_crc->setCaption( "" );
	QCheckBox_blade_crc->setGeometry( 8, 100, 113, 29 );
	QCheckBox_blade_crc->setMinimumSize( 0, 0 );
	QCheckBox_blade_crc->setMaximumSize( 32767, 32767 );
	QCheckBox_blade_crc->setMouseTracking( FALSE);
	QCheckBox_blade_crc->setSizeIncrement( 0, 0 );
	QCheckBox_blade_crc->setText( i18n ( "enable CRC" ) );
	QCheckBox_blade_crc->setAutoResize( FALSE );
	QCheckBox_blade_crc->setAutoRepeat( FALSE );
	QCheckBox_blade_crc->show();

	QCheckBox_stereo->setGeometry( 8, 125, 113, 29 );
	QCheckBox_stereo->show();

	QCheckBox_tempfiles->setChecked( 0 );
	QCheckBox_tempfiles->setEnabled( 0 );

 	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "32000" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->show();
};
void KrabWidget::initLayout_lame()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_lame_br = new QComboBox ( QGroupBox_options, "QComboBox_lame_br" );
	QComboBox_lame_ql = new QComboBox ( QGroupBox_options, "QComboBox_lame_ql" );
	QCheckBox_lame_copyright = new QCheckBox ( QGroupBox_options, "QCheckBox_lame_copyright");
	QCheckBox_lame_original = new QCheckBox ( QGroupBox_options, "QCheckBox_lame_original");
	QCheckBox_lame_fast = new QCheckBox ( QGroupBox_options, "QCheckBox_lame_fast");
	QCheckBox_lame_gui = new QCheckBox ( QGroupBox_options, "QCheckBox_lame_gui");

	QComboBox_lame_br->setCaption( "" );
	QComboBox_lame_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_lame_br->setMouseTracking( FALSE);
	QComboBox_lame_br->setSizeIncrement( 0, 0 );
	QComboBox_lame_br->setSizeLimit( 10 );
	QComboBox_lame_br->setMaxCount( 2147483647 );
	QComboBox_lame_br->setAutoResize( FALSE );
	QComboBox_lame_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_lame_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_lame[i] );
		temp = "";
		if ( bitrate_lame[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_lame_br->insertItem( temp );
	};
	QComboBox_lame_br->show();
	connect( QComboBox_lame_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QComboBox_lame_ql->setCaption( "" );
	QComboBox_lame_ql->setGeometry( 8, 50, 113, 29 );
	QComboBox_lame_ql->setMinimumSize( 0, 0 );
	QComboBox_lame_ql->setMaximumSize( 32767, 32767 );
	QComboBox_lame_ql->setMouseTracking( FALSE);
	QComboBox_lame_ql->setSizeIncrement( 0, 0 );
	QComboBox_lame_ql->setSizeLimit( 10 );
	QComboBox_lame_ql->setMaxCount( 11 );
	QComboBox_lame_ql->setAutoResize( FALSE );
	QComboBox_lame_ql->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  0" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  1" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  2" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  3" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  4" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  5" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  6" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  7" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  8" ) );
	QComboBox_lame_ql->insertItem( i18n ( "VBR Quality:  9" ) );
	QComboBox_lame_ql->insertItem( i18n ( "No variable bitrate" ) );
	QComboBox_lame_ql->show();

	QCheckBox_lame_copyright->setCaption( "" );
	QCheckBox_lame_copyright->setGeometry( 8, 82, 113, 20 );
	QCheckBox_lame_copyright->setMouseTracking( FALSE);
	QCheckBox_lame_copyright->setSizeIncrement( 0, 0 );
	QCheckBox_lame_copyright->setText( i18n ( "copyright" ) );
	QCheckBox_lame_copyright->setAutoResize( FALSE );
	QCheckBox_lame_copyright->setAutoRepeat( FALSE );
	QCheckBox_lame_copyright->show();

	QCheckBox_lame_original->setCaption( "" );
	QCheckBox_lame_original->setGeometry( 8, 102, 113, 20 );
	QCheckBox_lame_original->setMouseTracking( FALSE);
	QCheckBox_lame_original->setSizeIncrement( 0, 0 );
	QCheckBox_lame_original->setText( i18n ( "Original" ) );
	QCheckBox_lame_original->setAutoResize( FALSE );
	QCheckBox_lame_original->setAutoRepeat( FALSE );
	QCheckBox_lame_original->show();

	QCheckBox_lame_fast->setCaption( "" );
	QCheckBox_lame_fast->setGeometry( 8, 122, 113, 20 );
	QCheckBox_lame_fast->setMouseTracking( FALSE);
	QCheckBox_lame_fast->setSizeIncrement( 0, 0 );
	QCheckBox_lame_fast->setText( i18n ( "fast encoding" ) );
	QCheckBox_lame_fast->setAutoResize( FALSE );
	QCheckBox_lame_fast->setAutoRepeat( FALSE );
	QCheckBox_lame_fast->show();

        QCheckBox_lame_gui->setCaption( "" );
        QCheckBox_lame_gui->setGeometry( 8, 142, 113, 20 );
        QCheckBox_lame_gui->setMouseTracking( FALSE);
        QCheckBox_lame_gui->setSizeIncrement( 0, 0 );
        QCheckBox_lame_gui->setText( i18n ( "enable GUI" ) );
        QCheckBox_lame_gui->setAutoResize( FALSE );
        QCheckBox_lame_gui->setAutoRepeat( FALSE );
        QCheckBox_lame_gui->show();

//	QCheckBox_tempfiles->setChecked( 0 );
//	QCheckBox_tempfiles->setEnabled( 0 );

	QCheckBox_stereo->setGeometry( 8, 162, 113, 20 );
	QCheckBox_stereo->show();

 	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "32000" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->show();

};
void KrabWidget::initLayout_encode()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_encode_br = new QComboBox ( QGroupBox_options, "QComboBox_encode_br" );
	QComboBox_encode_ql = new QComboBox ( QGroupBox_options, "QComboBox_encode_ql" );
	QCheckBox_encode_copyright = new QCheckBox ( QGroupBox_options, "QCheckBox_encode_copyright");
	QCheckBox_encode_original = new QCheckBox ( QGroupBox_options, "QCheckBox_encode_original");
	QCheckBox_encode_crc = new QCheckBox ( QGroupBox_options, "QCheckBox_encode_crc");

	QComboBox_encode_br->setCaption( "" );
	QComboBox_encode_br->setGeometry( 8, 16, 113, 29 );
	QComboBox_encode_br->setMouseTracking( FALSE);
	QComboBox_encode_br->setSizeIncrement( 0, 0 );
	QComboBox_encode_br->setSizeLimit( 10 );
	QComboBox_encode_br->setMaxCount( 2147483647 );
	QComboBox_encode_br->setAutoResize( FALSE );
	QComboBox_encode_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_encode_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_encode[i] );
		temp = "";
		if ( bitrate_blade[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_encode_br->insertItem( temp );
	};
	QComboBox_encode_br->show();
	connect( QComboBox_encode_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QComboBox_encode_ql->setCaption( "" );
	QComboBox_encode_ql->setGeometry( 8, 50, 113, 29 );
	QComboBox_encode_ql->setMinimumSize( 0, 0 );
	QComboBox_encode_ql->setMaximumSize( 32767, 32767 );
	QComboBox_encode_ql->setMouseTracking( FALSE);
	QComboBox_encode_ql->setSizeIncrement( 0, 0 );
	QComboBox_encode_ql->setSizeLimit( 10 );
	QComboBox_encode_ql->setMaxCount( 11 );
	QComboBox_encode_ql->setAutoResize( FALSE );
	QComboBox_encode_ql->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  0.02" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  0.10" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  0.25" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  0.50" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  0.75" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  1.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  2.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality:  5.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality: 10.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality: 25.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality: 50.00" ) );
	QComboBox_encode_ql->insertItem( i18n ( "Quality: 99.99" ) );
	QComboBox_encode_ql->show();

	QCheckBox_encode_copyright->setCaption( "" );
	QCheckBox_encode_copyright->setGeometry( 8, 82, 113, 26 );
	QCheckBox_encode_copyright->setMouseTracking( FALSE);
	QCheckBox_encode_copyright->setText( i18n ( "copyright" ) );
	QCheckBox_encode_copyright->setAutoResize( FALSE );
	QCheckBox_encode_copyright->setAutoRepeat( FALSE );
	QCheckBox_encode_copyright->show();

	QCheckBox_encode_original->setCaption( "" );
	QCheckBox_encode_original->setGeometry( 8, 102, 113, 26 );
	QCheckBox_encode_original->setMouseTracking( FALSE);
	QCheckBox_encode_original->setText( i18n ( "Original" ) );
	QCheckBox_encode_original->setAutoResize( FALSE );
	QCheckBox_encode_original->setAutoRepeat( FALSE );
	QCheckBox_encode_original->show();

	QCheckBox_encode_crc->setCaption( "" );
	QCheckBox_encode_crc->setGeometry( 8, 122, 113, 26 );
	QCheckBox_encode_crc->setMouseTracking( FALSE);
	QCheckBox_encode_crc->setSizeIncrement( 0, 0 );
	QCheckBox_encode_crc->setText( i18n ( "enable CRC" ) );
	QCheckBox_encode_crc->setAutoResize( FALSE );
	QCheckBox_encode_crc->setAutoRepeat( FALSE );
	QCheckBox_encode_crc->show();

	QCheckBox_stereo->setGeometry( 8, 142, 113, 26 );
	QCheckBox_stereo->show();

	QCheckBox_tempfiles->setChecked( 0 );
	QCheckBox_tempfiles->setEnabled( 0 );

 	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "32000" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->show();

};
void KrabWidget::initLayout_l3()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_l3_br = new QComboBox ( QGroupBox_options, "QComboBox1" );
	QCheckBox_l3_hq = new QCheckBox ( QGroupBox_options, "QCheckBox_l3_hq");
	QCheckBox_l3_crc = new QCheckBox ( QGroupBox_options, "QCheckBox_l3_crc");
	QCheckBox_l3_speech = new QCheckBox ( QGroupBox_options, "QCheckBox_l3_speech");

	QComboBox_l3_br->setCaption( "" );
	QComboBox_l3_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_l3_br->setMinimumSize( 0, 0 );
	QComboBox_l3_br->setMaximumSize( 32767, 32767 );
	QComboBox_l3_br->setMouseTracking( FALSE);
	QComboBox_l3_br->setSizeIncrement( 0, 0 );
	QComboBox_l3_br->setSizeLimit( 10 );
	QComboBox_l3_br->setMaxCount( 2147483647 );
	QComboBox_l3_br->setAutoResize( FALSE );
	QComboBox_l3_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_l3_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_l3[i] );
		temp = "";
		if ( bitrate_l3[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_l3_br->insertItem( temp );
	};
	QComboBox_l3_br->show();
	connect( QComboBox_l3_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QCheckBox_l3_hq->setCaption( "" );
	QCheckBox_l3_hq->setGeometry( 8, 50, 113, 29 );
	QCheckBox_l3_hq->setMinimumSize( 0, 0 );
	QCheckBox_l3_hq->setMaximumSize( 32767, 32767 );
	QCheckBox_l3_hq->setMouseTracking( FALSE);
	QCheckBox_l3_hq->setSizeIncrement( 0, 0 );
	QCheckBox_l3_hq->setText( i18n ( "High Quality" ) );
	QCheckBox_l3_hq->setAutoResize( FALSE );
	QCheckBox_l3_hq->setAutoRepeat( FALSE );
	QCheckBox_l3_hq->show();

	QCheckBox_l3_crc->setCaption( "" );
	QCheckBox_l3_crc->setGeometry( 8, 75, 113, 29 );
	QCheckBox_l3_crc->setMinimumSize( 0, 0 );
	QCheckBox_l3_crc->setMaximumSize( 32767, 32767 );
	QCheckBox_l3_crc->setMouseTracking( FALSE);
	QCheckBox_l3_crc->setSizeIncrement( 0, 0 );
	QCheckBox_l3_crc->setText( i18n ( "enable CRC" ) );
	QCheckBox_l3_crc->setAutoResize( FALSE );
	QCheckBox_l3_crc->setAutoRepeat( FALSE );
	QCheckBox_l3_crc->show();

	QCheckBox_l3_speech->setCaption( "" );
	QCheckBox_l3_speech->setGeometry( 8, 100, 113, 29 );
	QCheckBox_l3_speech->setMinimumSize( 0, 0 );
	QCheckBox_l3_speech->setMaximumSize( 32767, 32767 );
	QCheckBox_l3_speech->setMouseTracking( FALSE);
	QCheckBox_l3_speech->setSizeIncrement( 0, 0 );
	QCheckBox_l3_speech->setText( i18n ( "optimize speech" ) );
	QCheckBox_l3_speech->setAutoResize( FALSE );
	QCheckBox_l3_speech->setAutoRepeat( FALSE );
	QCheckBox_l3_speech->show();

	QCheckBox_stereo->setGeometry( 8, 125, 113, 29 );
	QCheckBox_stereo->show();

	QCheckBox_tempfiles->setChecked( 0 );
	QCheckBox_tempfiles->setEnabled( 0 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "32000Hz" );
	QComboBox_bitrate->insertItem( "44100Hz" );
	QComboBox_bitrate->insertItem( "48000Hz" );
	QComboBox_bitrate->show();

};
void KrabWidget::initLayout_mp3()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_mp3_br     = new QComboBox ( QGroupBox_options, "QComboBox_mp3_br" );
	QComboBox_mp3_ql     = new QComboBox ( QGroupBox_options, "QComboBox_mp3_ql" );
	QCheckBox_mp3_crc    = new QCheckBox ( QGroupBox_options, "QCheckBox_mp3_crc" );

	QComboBox_mp3_br->setCaption( "" );
	QComboBox_mp3_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_mp3_br->setMinimumSize( 0, 0 );
	QComboBox_mp3_br->setMaximumSize( 32767, 32767 );
	QComboBox_mp3_br->setMouseTracking( FALSE);
	QComboBox_mp3_br->setSizeIncrement( 0, 0 );
	QComboBox_mp3_br->setSizeLimit( 10 );
	QComboBox_mp3_br->setMaxCount( 2147483647 );
	QComboBox_mp3_br->setAutoResize( FALSE );
	QComboBox_mp3_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_mp3_max; i++)
	{
		QString temp2;
		temp2.setNum( bitrate_mp3[i] );
		temp = "";
		if ( bitrate_mp3[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_mp3_br->insertItem( temp );
	};
	QComboBox_mp3_br->show();
	connect( QComboBox_mp3_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QComboBox_mp3_ql->setCaption( "" );
	QComboBox_mp3_ql->setGeometry( 8, 55, 113, 29 );
	QComboBox_mp3_ql->setMinimumSize( 0, 0 );
	QComboBox_mp3_ql->setMaximumSize( 32767, 32767 );
	QComboBox_mp3_ql->setMouseTracking( FALSE);
	QComboBox_mp3_ql->setSizeIncrement( 0, 0 );
	QComboBox_mp3_ql->setSizeLimit( 10 );
	QComboBox_mp3_ql->setMaxCount( 11 );
	QComboBox_mp3_ql->setAutoResize( FALSE );
	QComboBox_mp3_ql->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 0" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 1" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 2" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 3" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 4" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 5" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 6" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 7" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 8" ) );
	QComboBox_mp3_ql->insertItem( i18n ( "Quality: 9" ) );
	QComboBox_mp3_ql->show();

	QCheckBox_mp3_crc->setCaption( "" );
	QCheckBox_mp3_crc->setGeometry( 8, 85, 113, 29 );
	QCheckBox_mp3_crc->setMinimumSize( 0, 0 );
	QCheckBox_mp3_crc->setMaximumSize( 32767, 32767 );
	QCheckBox_mp3_crc->setMouseTracking( FALSE);
	QCheckBox_mp3_crc->setSizeIncrement( 0, 0 );
	QCheckBox_mp3_crc->setText( i18n ( "enable CRC" ) );
	QCheckBox_mp3_crc->setAutoResize( FALSE );
	QCheckBox_mp3_crc->setAutoRepeat( FALSE );
	QCheckBox_mp3_crc->show();

	QCheckBox_stereo->setGeometry( 8, 110, 113, 29 );
	QCheckBox_stereo->show();

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( i18n("default Hz") );
	QComboBox_bitrate->show();

};
void KrabWidget::initLayout_xing()
{
	QString temp, temp2;
	unsigned int i;

	QComboBox_xing_br        = new QComboBox ( QGroupBox_options, "QComboBox_xing_br" );
	QComboBox_xing_ql        = new QComboBox ( QGroupBox_options, "QComboBox_xing_ql" );
	QCheckBox_xing_vbr       = new QCheckBox ( QGroupBox_options, "QCheckBox_xing_vbr" );
	QCheckBox_xing_copyright = new QCheckBox ( QGroupBox_options, "QCheckBox_xing_copyright" );
	QCheckBox_xing_original  = new QCheckBox ( QGroupBox_options, "QCheckBox_xing_original" );
	QCheckBox_xing_nohigh    = new QCheckBox ( QGroupBox_options, "QCheckBox_xing_nohigh" );

	QComboBox_xing_br->setCaption( "" );
	QComboBox_xing_br->setGeometry( 8, 20, 113, 29 );
	QComboBox_xing_br->setMouseTracking( FALSE);
	QComboBox_xing_br->setSizeIncrement( 0, 0 );
	QComboBox_xing_br->setSizeLimit( 10 );
	QComboBox_xing_br->setMaxCount( 2147483647 );
	QComboBox_xing_br->setAutoResize( FALSE );
	QComboBox_xing_br->setInsertionPolicy( QComboBox::AtBottom );
	for (i=0; i<bitrate_xing_max; i++)
	{
		temp2.setNum( bitrate_xing[i] );
		temp = "";
		if ( bitrate_xing[i] <100 )
			temp = " ";
		temp += temp2;
		temp += "000 Bps";
		QComboBox_xing_br->insertItem( temp );
	};
	QComboBox_xing_br->hide();
	connect( QComboBox_xing_br, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QComboBox_xing_ql->setCaption( "" );
	QComboBox_xing_ql->setGeometry( 8, 20, 113, 29 );
	QComboBox_xing_ql->setMouseTracking( FALSE);
	QComboBox_xing_ql->setSizeIncrement( 0, 0 );
	QComboBox_xing_ql->setSizeLimit( 10 );
	QComboBox_xing_ql->setMaxCount( 11 );
	QComboBox_xing_ql->setAutoResize( FALSE );
	QComboBox_xing_ql->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability:   1 (~96kbps)" ) );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability:  30 (~112kbps)" ) );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability:  50 (~128kbps)" ) );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability:  75 (~160kbps)" ) );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability: 100 (~192kbps)" ) );
	QComboBox_xing_ql->insertItem( i18n ( "VBR variability: 150 (max)" ) );
	QComboBox_xing_ql->hide();
	connect( QComboBox_xing_ql, SIGNAL(activated(int)), SLOT(todolist_update(int)) );

	QCheckBox_xing_vbr->setCaption( "" );
	QCheckBox_xing_vbr->setGeometry( 8, 50, 113, 26 );
	QCheckBox_xing_vbr->setMouseTracking( FALSE);
	QCheckBox_xing_vbr->setSizeIncrement( 0, 0 );
	QCheckBox_xing_vbr->setText( i18n ( "enable VBR" ) );
	QCheckBox_xing_vbr->setAutoResize( FALSE );
	QCheckBox_xing_vbr->setAutoRepeat( FALSE );
	QCheckBox_xing_vbr->show();

	QCheckBox_xing_copyright->setCaption( "" );
	QCheckBox_xing_copyright->setGeometry( 8, 70, 113, 26 );
	QCheckBox_xing_copyright->setMouseTracking( FALSE);
	QCheckBox_xing_copyright->setText( i18n ( "copyright" ) );
	QCheckBox_xing_copyright->setAutoResize( FALSE );
	QCheckBox_xing_copyright->setAutoRepeat( FALSE );
	QCheckBox_xing_copyright->show();

	QCheckBox_xing_original->setCaption( "" );
	QCheckBox_xing_original->setGeometry( 8, 90, 113, 26 );
	QCheckBox_xing_original->setMouseTracking( FALSE);
	QCheckBox_xing_original->setText( i18n ( "Original" ) );
	QCheckBox_xing_original->setAutoResize( FALSE );
	QCheckBox_xing_original->setAutoRepeat( FALSE );
	QCheckBox_xing_original->show();

	QCheckBox_xing_nohigh->setCaption( "" );
	QCheckBox_xing_nohigh->setGeometry( 8, 110, 113, 26 );
	QCheckBox_xing_nohigh->setMouseTracking( FALSE);
	QCheckBox_xing_nohigh->setText( i18n ( "no high Freq." ) );
	QCheckBox_xing_nohigh->setAutoResize( FALSE );
	QCheckBox_xing_nohigh->setAutoRepeat( FALSE );
	QCheckBox_xing_nohigh->show();

	QCheckBox_stereo->setGeometry( 8, 130, 113, 26 );
	QCheckBox_stereo->show();

 	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "16000" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "24000" );
	QComboBox_bitrate->insertItem( "32000" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->show();

	connect( QCheckBox_xing_vbr, SIGNAL(toggled(bool)), SLOT(xing_vbr_toggled(bool)) );

	QCheckBox_tempfiles->setChecked( 0 );
	QCheckBox_tempfiles->setEnabled( 0 );
};
void KrabWidget::initLayout_cdrecord()
{
	QComboBox_cdr_device    = new QComboBox ( QGroupBox_options, "QComboBox_cdr_device" );
	QComboBox_cdr_speed     = new QComboBox ( QGroupBox_options, "QComboBox_cdr_speed" );
	QPushButton_cdr_size	= new QPushButton ( QGroupBox_options, "QPushButton_cdr_size" );
	QPushButton_cdr_blank   = new QPushButton ( QGroupBox_options, "QPushButton_cdr_blank" );
	QPushButton_cdr_fix     = new QPushButton ( QGroupBox_options, "QPushButton_cdr_fix" );
	QCheckBox_cdr_fix       = new QCheckBox ( QGroupBox_options, "QCheckBox_cdr_fix" );
	QCheckBox_cdr_dummy     = new QCheckBox ( QGroupBox_options, "QCheckBox_cdr_dummy" );
	QCheckBox_cdr_eject     = new QCheckBox ( QGroupBox_options, "QCheckBox_cdr_eject" );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "44100" );

	QCheckBox_stereo->setChecked( 1 );
	QCheckBox_16bit->setChecked( 1 );
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();

	QComboBox_cdr_device->setCaption( "" );
	QComboBox_cdr_device->setGeometry( 8, 20, 113, 29 );
	QComboBox_cdr_device->setMouseTracking( FALSE);
	QComboBox_cdr_device->setSizeIncrement( 0, 0 );
	QComboBox_cdr_device->setSizeLimit( 10 );
	QComboBox_cdr_device->setMaxCount( 2147483647 );
	QComboBox_cdr_device->setAutoResize( FALSE );
	QComboBox_cdr_device->setInsertionPolicy( QComboBox::AtBottom );
	for (unsigned int i=1; i<=cdrecord_devices_count; i++)
		QComboBox_cdr_device->insertItem( cdrecord_device[i] );
	QComboBox_cdr_device->show();

	QComboBox_cdr_speed->setCaption( "" );
	QComboBox_cdr_speed->setGeometry( 8, 50, 56, 29 );
	QComboBox_cdr_speed->setMouseTracking( FALSE);
	QComboBox_cdr_speed->setSizeIncrement( 0, 0 );
	QComboBox_cdr_speed->setSizeLimit( 10 );
	QComboBox_cdr_speed->setMaxCount( 2147483647 );
	QComboBox_cdr_speed->setAutoResize( FALSE );
	QComboBox_cdr_speed->setInsertionPolicy( QComboBox::AtBottom );
	QComboBox_cdr_speed->insertItem( i18n( "1x" ) );
	QComboBox_cdr_speed->insertItem( i18n( "2x" ) );
	QComboBox_cdr_speed->insertItem( i18n( "4x" ) );
	QComboBox_cdr_speed->insertItem( i18n( "6x" ) );
	QComboBox_cdr_speed->insertItem( i18n( "8x" ) );
	QComboBox_cdr_speed->show();

	QPushButton_cdr_size->setCaption( "" );
	QPushButton_cdr_size->setGeometry( 65, 50, 56, 29 );
	QPushButton_cdr_size->setText( i18n("no disc") );
//QPushButton_cdr_size->setAlignment( AlignRight|AlignVCenter );
	connect( QPushButton_cdr_size, SIGNAL(clicked()), SLOT(cdr_check()) );
	QPushButton_cdr_size->show();

	QPushButton_cdr_blank->setCaption( "" );
	QPushButton_cdr_blank->setGeometry( 8, 80, 56, 29 );
	QPushButton_cdr_blank->setText( i18n( "blank it" ) );
	connect( QPushButton_cdr_blank, SIGNAL(clicked()), SLOT(cdr_blank_start()) );
	QPushButton_cdr_blank->show();

	QPushButton_cdr_fix->setCaption( "" );
	QPushButton_cdr_fix->setGeometry( 65, 80, 56, 29 );
	QPushButton_cdr_fix->setText( i18n( "fix it" ) );
	connect( QPushButton_cdr_fix, SIGNAL(clicked()), SLOT(cdr_fix_()) );
	QPushButton_cdr_fix->show();

	QCheckBox_cdr_dummy->setCaption( "" );
	QCheckBox_cdr_dummy->setGeometry( 8, 120, 113, 20 );
	QCheckBox_cdr_dummy->setMouseTracking( FALSE);
	QCheckBox_cdr_dummy->setSizeIncrement( 0, 0 );
	QCheckBox_cdr_dummy->setText( i18n ( "dummy" ) );
	QCheckBox_cdr_dummy->setAutoResize( FALSE );
	QCheckBox_cdr_dummy->setAutoRepeat( FALSE );
	QCheckBox_cdr_dummy->show();

	QCheckBox_cdr_eject->setCaption( "" );
	QCheckBox_cdr_eject->setGeometry( 8, 140, 113, 20 );
	QCheckBox_cdr_eject->setMouseTracking( FALSE);
	QCheckBox_cdr_eject->setSizeIncrement( 0, 0 );
	QCheckBox_cdr_eject->setText( i18n ( "eject" ) );
	QCheckBox_cdr_eject->setAutoResize( FALSE );
	QCheckBox_cdr_eject->setAutoRepeat( FALSE );
	QCheckBox_cdr_eject->show();

	QCheckBox_cdr_fix->setCaption( "" );
	QCheckBox_cdr_fix->setGeometry( 8, 160, 113, 20 );
	QCheckBox_cdr_fix->setMouseTracking( FALSE);
	QCheckBox_cdr_fix->setSizeIncrement( 0, 0 );
	QCheckBox_cdr_fix->setText( i18n ( "fixate CD" ) );
	QCheckBox_cdr_fix->setAutoResize( FALSE );
	QCheckBox_cdr_fix->setAutoRepeat( FALSE );
	QCheckBox_cdr_fix->show();

	QCheckBox_tempfiles->setChecked( 0 );
	QCheckBox_tempfiles->setEnabled( 0 );
	KSlider_smp->setValue( 0 );
	KSlider_smp->setEnabled( 0 );
};
void KrabWidget::initLayout_wav()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QLineEdit_bitrate_other->setMaxLength( 5 );

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_dat()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_stereo->blockSignals(0);//always mono
	QCheckBox_stereo->setEnabled(0);
	QCheckBox_stereo->setChecked( 1 );
	QCheckBox_16bit->blockSignals(1);//always 32bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked( 1 );
	QCheckBox_16bit->setText( i18n ( "32bit" ) );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_cdr()
{
	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "44100" );

	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
	QCheckBox_stereo->blockSignals(1);//always stereo
	QCheckBox_stereo->setEnabled(0);
	QCheckBox_stereo->setChecked( 1 );
	QCheckBox_16bit->blockSignals(1);//always 16bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked( 1 );
};
void KrabWidget::initLayout_raw()
{
	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "44100" );

	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
	QCheckBox_stereo->blockSignals(1);//always stereo
	QCheckBox_stereo->setEnabled(0);
	QCheckBox_stereo->setChecked( 1 );
	QCheckBox_16bit->blockSignals(1);//always 16bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked( 1 );
};
void KrabWidget::initLayout_svx()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_aiff()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_au()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_maud()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_sf()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );
	QCheckBox_16bit->show();
	QCheckBox_16bit->blockSignals(1); //always 16bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked(1);

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_smp()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );
	QCheckBox_stereo->blockSignals(1);//always mono
	QCheckBox_stereo->setEnabled(0);
	QCheckBox_stereo->setChecked( 0 );
	QCheckBox_16bit->blockSignals(1);//always 16bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked( 1 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_voc()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_cvs()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_vms()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_sndr()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_sndt()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_txw()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_wve()
{
	QCheckBox_stereo->setGeometry( 10, 25, 111, 20 );
	QCheckBox_16bit->setGeometry( 10, 50, 111, 20 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "100" );
	QComboBox_bitrate->insertItem( "900" );
	QComboBox_bitrate->insertItem( "1575" );
	QComboBox_bitrate->insertItem( "3150" );
	QComboBox_bitrate->insertItem( "3675" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "14700" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->insertItem( "44100" );
	QComboBox_bitrate->insertItem( "48000" );
	QComboBox_bitrate->insertItem( "50000" );
	QComboBox_bitrate->insertItem( i18n("Other") );
	QComboBox_bitrate->show();

	QComboBox_bitrate->show();
	QLineEdit_bitrate_other->show();
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
};
void KrabWidget::initLayout_hcom()
{
	QCheckBox_stereo->show();
	QCheckBox_16bit->show();
	QCheckBox_stereo->blockSignals(1);//always mono
	QCheckBox_stereo->setEnabled(0);
	QCheckBox_stereo->setChecked( 0 );
	QCheckBox_16bit->blockSignals(1);//always 8bit
	QCheckBox_16bit->setEnabled(0);
	QCheckBox_16bit->setChecked( 0 );

	QComboBox_bitrate->clear();
	QComboBox_bitrate->insertItem( "5512" );
	QComboBox_bitrate->insertItem( "7350" );
	QComboBox_bitrate->insertItem( "11025" );
	QComboBox_bitrate->insertItem( "22050" );
	QComboBox_bitrate->show();
};
void KrabWidget::initLayout_8hz_del()
{
	delete QComboBox_8hz_br;
	delete QCheckBox_8hz_copyright;
	delete QCheckBox_8hz_original;
	QComboBox_8hz_br = NULL;
	QCheckBox_8hz_copyright = NULL;
	QCheckBox_8hz_original = NULL;
};
void KrabWidget::initLayout_blade_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_blade_br;
	delete QCheckBox_blade_copyright;
	delete QCheckBox_blade_private;
	delete QCheckBox_blade_crc;
	QComboBox_blade_br = NULL;
	QCheckBox_blade_copyright = NULL;
	QCheckBox_blade_private = NULL;
	QCheckBox_blade_crc = NULL;

	QCheckBox_tempfiles->setEnabled( 1 );
	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_lame_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_lame_br;
	delete QComboBox_lame_ql;
	delete QCheckBox_lame_copyright;
	delete QCheckBox_lame_original;
	delete QCheckBox_lame_fast;
	delete QCheckBox_lame_gui;
	QComboBox_lame_br = NULL;
	QComboBox_lame_ql = NULL;
	QCheckBox_lame_copyright = NULL;
	QCheckBox_lame_original = NULL;
	QCheckBox_lame_fast = NULL;
	QCheckBox_lame_gui = NULL;

	QCheckBox_tempfiles->setEnabled( 1 );
	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_encode_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_encode_br;
	delete QComboBox_encode_ql;
	delete QCheckBox_encode_copyright;
	delete QCheckBox_encode_original;
	delete QCheckBox_encode_crc;
	QComboBox_encode_br = NULL;
	QComboBox_encode_ql = NULL;
	QCheckBox_encode_copyright = NULL;
	QCheckBox_encode_original = NULL;
	QCheckBox_encode_crc = NULL;

//	QCheckBox_tempfiles->setEnabled( 1 );
	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_l3_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_l3_br;
	delete QCheckBox_l3_hq;
	delete QCheckBox_l3_crc;
	delete QCheckBox_l3_speech;
	QComboBox_l3_br = NULL;
	QCheckBox_l3_hq = NULL;
	QCheckBox_l3_crc = NULL;
	QCheckBox_l3_speech = NULL;

	QCheckBox_tempfiles->setEnabled( 1 );
	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_mp3_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_mp3_br;
	delete QComboBox_mp3_ql;
	delete QCheckBox_mp3_crc;
	QComboBox_mp3_br     = NULL;
	QComboBox_mp3_ql     = NULL;
	QCheckBox_mp3_crc    = NULL;

	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_xing_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	delete QComboBox_xing_br;
	delete QComboBox_xing_ql;
	delete QCheckBox_xing_copyright;
	delete QCheckBox_xing_original;
	delete QCheckBox_xing_vbr;
	delete QCheckBox_xing_nohigh;
	QComboBox_xing_br = NULL;
	QComboBox_xing_ql = NULL;
	QCheckBox_xing_copyright = NULL;
	QCheckBox_xing_original = NULL;
	QCheckBox_xing_nohigh = NULL;
	QCheckBox_xing_vbr = NULL;

	QCheckBox_tempfiles->setEnabled( 1 );
	QCheckBox_stereo->hide();
};
void KrabWidget::initLayout_cdrecord_del()
{
	delete QComboBox_cdr_device;
	delete QComboBox_cdr_speed;
	delete QPushButton_cdr_blank;
	delete QPushButton_cdr_fix;
	delete QPushButton_cdr_size;
	delete QCheckBox_cdr_dummy;
	delete QCheckBox_cdr_eject;
	delete QCheckBox_cdr_fix;
	QComboBox_cdr_device     = NULL;
	QComboBox_cdr_speed      = NULL;
	QPushButton_cdr_blank    = NULL;
	QPushButton_cdr_fix      = NULL;
	QPushButton_cdr_size	 = NULL;
	QCheckBox_cdr_dummy      = NULL;
	QCheckBox_cdr_eject      = NULL;
	QCheckBox_cdr_fix        = NULL;

	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
	QCheckBox_tempfiles->setEnabled( 1 );
	KSlider_smp->setEnabled( 1 );
};
void KrabWidget::initLayout_wav_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	if (Init)
		return;
};
void KrabWidget::initLayout_dat_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_16bit->setText( i18n ( "16bit" ) );
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
};
void KrabWidget::initLayout_cdr_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
};
void KrabWidget::initLayout_raw_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
};
void KrabWidget::initLayout_svx_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_aiff_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_au_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_maud_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_sf_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_16bit->blockSignals(0);
};
void KrabWidget::initLayout_smp_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
};
void KrabWidget::initLayout_voc_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_cvs_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_vms_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_sndr_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_sndt_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_txw_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_wve_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
};
void KrabWidget::initLayout_hcom_del()
{
	QLineEdit_bitrate_other->hide();
	QComboBox_bitrate->hide();
	QCheckBox_stereo->hide();
	QCheckBox_16bit->hide();
	QCheckBox_stereo->setEnabled(1);
	QCheckBox_16bit->setEnabled(1);
	QCheckBox_stereo->blockSignals(0);
	QCheckBox_16bit->blockSignals(0);
};

void KrabWidget::cd_change()
{
	cd_change_Widget = new QWidget( 0, "Dialog", WStyle_DialogBorder|WStyle_Title|WStyle_SysMenu );
        cd_change_Widget->resize( 320,120 );
        cd_change_Widget->setFixedSize( 320, 120 );
	cd_change_Widget->setCaption( i18n("Please change your CD !") );

        cd_change_PushButton = new QPushButton( cd_change_Widget, "PushButton" );
        cd_change_PushButton->setGeometry( 0, 90, 320, 30 );
        cd_change_PushButton->setMinimumSize( 0, 0 );
        cd_change_PushButton->setMaximumSize( 32767, 32767 );
        cd_change_PushButton->setFocusPolicy( QWidget::TabFocus );
        cd_change_PushButton->setBackgroundMode( QWidget::PaletteBackground );
        cd_change_PushButton->setFontPropagation( QWidget::NoChildren );
        cd_change_PushButton->setPalettePropagation( QWidget::NoChildren );
        cd_change_PushButton->setText( i18n("OK") );
        cd_change_PushButton->setAutoRepeat( FALSE );
        cd_change_PushButton->setAutoResize( FALSE );

        cd_change_Label_1 = new QLabel( cd_change_Widget, "Label_1" );
        cd_change_Label_1->setGeometry( 0, 0, 320, 20 );
        cd_change_Label_1->setMinimumSize( 0, 0 );
        cd_change_Label_1->setMaximumSize( 32767, 32767 );
        cd_change_Label_1->setFocusPolicy( QWidget::NoFocus );
        cd_change_Label_1->setBackgroundMode( QWidget::PaletteBackground );
        cd_change_Label_1->setFontPropagation( QWidget::NoChildren );
        cd_change_Label_1->setPalettePropagation( QWidget::NoChildren );
        cd_change_Label_1->setText( i18n("Please change your CD in ") );
        cd_change_Label_1->setAlignment( 289 );
        cd_change_Label_1->setMargin( -1 );

        cd_change_Label_2 = new QLabel( cd_change_Widget, "Label_2" );
        cd_change_Label_2->setGeometry( 0, 20, 320, 20 );
        cd_change_Label_2->setMinimumSize( 0, 0 );
        cd_change_Label_2->setMaximumSize( 32767, 32767 );
        cd_change_Label_2->setFocusPolicy( QWidget::NoFocus );
        cd_change_Label_2->setBackgroundMode( QWidget::PaletteBackground );
        cd_change_Label_2->setFontPropagation( QWidget::NoChildren );
        cd_change_Label_2->setPalettePropagation( QWidget::NoChildren );
        cd_change_Label_2->setText( i18n("and insert:") );
        cd_change_Label_2->setAlignment( 289 );
        cd_change_Label_2->setMargin( -1 );

        cd_change_Label_3 = new QLabel( cd_change_Widget, "Label_3" );
        cd_change_Label_3->setGeometry( 0, 50, 320, 20 );
        cd_change_Label_3->setMinimumSize( 0, 0 );
        cd_change_Label_3->setMaximumSize( 32767, 32767 );
        {
                QColorGroup normal( QColor( (unsigned int) QRgb(0) ), QColor( (unsigned int) QRgb(12632256) ),
			QColor( (unsigned int) QRgb(16777215) ), QColor( (unsigned int) QRgb(8421504) ), QColor( (unsigned int) QRgb(10789024) ),
			QColor( (unsigned int) QRgb(128) ), QColor( (unsigned int) QRgb(16777215) ) );
                QColorGroup disabled( QColor( (unsigned int) QRgb(8421504) ), QColor( (unsigned int) QRgb(12632256) ),
			 QColor( (unsigned int) QRgb(16777215) ), QColor( (unsigned int) QRgb(8421504) ), QColor( (unsigned int) QRgb(10789024) ),
			 QColor( (unsigned int) QRgb(8421504) ), QColor( (unsigned int) QRgb(12632256) ) );
                QColorGroup active( QColor( (unsigned int) QRgb(0) ), QColor( (unsigned int) QRgb(12632256) ), QColor( (unsigned int) QRgb(16777215) ),
			 QColor( (unsigned int) QRgb(8421504) ), QColor( (unsigned int) QRgb(10789024) ), QColor( (unsigned int) QRgb(0) ),
			 QColor( (unsigned int) QRgb(16777215) ) );
                QPalette palette( normal, disabled, active );
                cd_change_Label_3->setPalette( palette );
        }
        cd_change_Label_3->setFocusPolicy( QWidget::NoFocus );
        cd_change_Label_3->setBackgroundMode( QWidget::PaletteBackground );
        cd_change_Label_3->setFontPropagation( QWidget::NoChildren );
        cd_change_Label_3->setPalettePropagation( QWidget::NoChildren );
        cd_change_Label_3->setText( "" );
        cd_change_Label_3->setAlignment( 292 );
        cd_change_Label_3->setMargin( -1 );
};
