#include <kapp.h>
#include "krab.h"
#include "startup.h"

int main(int argc, char *argv[])
{
	const QString AppName = "krabber";
	KApplication app(argc, argv, AppName );

	Krab widget( 0, AppName);
	app.setMainWidget(&widget);
	app.setTopWidget(&widget);
	widget.show();

	for(int i = 1; i < argc; i++)
		widget.view->select_file( argv[i], i );

	widget.view->todolist_update();

	return app.exec();
}
