/* The Binary output file containing the VCD image */

#define BINARY_OUTPUT_FILE "vcd_image.bin"
#define VCD_TOC_FILE       "vcd.toc"

/* Some default settings for the Video CD */

#define CD_SYSTEM_ID "CD-RTOS CD-BRIDGE"  /* mandatory ? */
#define CD_VOLUME_ID "LINUX VIDEO CD"     /* arbitrary */

#define CD_VOLUME_SET_ID  " "
#define CD_PUBLISHER_ID   " "
#define CD_PREPARER_ID    " "
#define CD_APPLICATION_ID "CDI/CDI_VCD.APP;1"

/* The date for all timestamps (with the exception of expiration date) */

/* We set it to March, 1st, 2000, 12:00:00 GMT
   You are free to change that */

#define DATE_YEAR    2000
#define DATE_MONTH      3
#define DATE_DAY        1
#define DATE_HOUR      12
#define DATE_MINUTE     0
#define DATE_SECOND     0
#define DATE_TZDIFF     0  /* in units of 15 minutes from GMT */

#define ISO_FS_BLOCKS 750
